/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ticomViewer;

import java.awt.Component;
import javax.swing.ImageIcon;
import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;


/**
 *
 * @author karol
 */
class BusNodeTreeCellRenderer extends DefaultTreeCellRenderer
{  
    @Override
    public Component getTreeCellRendererComponent( JTree tree, Object value, 
            boolean selected, boolean expanded, boolean leaf, 
            int row, boolean hasFocus )
    {
        super.getTreeCellRendererComponent(tree, value, selected, expanded, leaf, row, hasFocus);
             
        Node n = (Node)value;       
        setText(n.getName());
       
        if( leaf )
        {
            if( n instanceof CanNodeDevice )
            {                
                int state = ((CanNodeDevice)n).getNodeState();
                switch( state )
                {
                    case NodeState.PREOPERATIONAL:
                        setIcon( getImageIcon("node_preoperational.gif"));
                        break;
                    case NodeState.OPERATIONAL:
                        setIcon( getImageIcon("node_operational.gif"));
                        break;
                    case NodeState.STOPPED:
                        setIcon(getImageIcon("node_stopped.gif"));
                        break;
                    default:
                        setIcon( getImageIcon( "node_noHeartBeat.gif"));
                    break;
                }  
            }
            else if( n instanceof TimeProducer) 
            {
                if( ((TimeProducer)n).getOn() ) setIcon( getImageIcon( "timeMessage_enabled.gif"));
                else setIcon( getImageIcon( "timeMessage_disabled.gif"));
            } else if( n instanceof SyncProducer ) 
            {
                if( ((SyncProducer)n).getOn() ) setIcon( getImageIcon("sync_enabled.gif"));
                else setIcon( getImageIcon("sync_disabled.gif"));
            }
        }
        else
        {
         if( n instanceof CanopenBusTreeModel ) 
         {
             setIcon( getImageIcon( "deviceGroup.gif"));
         } 
         
         else if( n instanceof CanDevices ) 
         {           
            int state = ((CanDevices)n).getEffectiveState();
            switch( state )
            {
                case NodeState.PREOPERATIONAL:
                    setIcon( getImageIcon("twoNodes_preoperational.gif"));
                    break;
                case NodeState.OPERATIONAL:
                    setIcon( getImageIcon( "twoNodes_operational.gif"));
                    break;
                case NodeState.STOPPED:
                    setIcon( getImageIcon( "twoNodes_stopped.gif"));
                    break;
                default:
                    setIcon( getImageIcon("twoNodes_unknown.gif"));
                break;
            }  
         }
        }
        return this;
    }
    
   public static ImageIcon getImageIcon(String gifName) 
   {
    return new ImageIcon(ClassLoader.getSystemResource( "Resources/" + gifName));
   }
}
