/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * FlashProgrammerDisplayer.java
 *
 * Created on 05-Dec-2008, 15:27:36
 */

package ticomViewer;

import java.awt.Color;

/**
 *
 * @author karol
 */
public class FlashProgrammerDisplayer extends javax.swing.JPanel
{
    private static final int IDLE = 0;
    private static final int SWITCHING_TO_PROGRAMMING_MODE = 1;
    private static final int SENDING_DATA = 2;
    private static final int REPROGRAMMING = 3;
    private static final int CHECKING_CONTROL_SUMS = 4;
    private static final int BOOTING = 5;
                
    private FlashProgrammer flashProgrammer;


    /** Creates new form FlashProgrammerDisplayer */
    public FlashProgrammerDisplayer()
    {
        initComponents();
        JProgressBar_sendingData.setMaximum(100);
        JProgressBar_sendingData.setMinimum(0);
        JProgressBar_sendingData.setValue(0);
    }

    void updateProgress(int progress)
    {
        System.out.println( "Progress: " + progress );
        JProgressBar_sendingData.setValue(progress);

    }

    void updateStatus(int[] status)
    {
        switch(status[0])
        {
            case IDLE:
                PANEL_idle.setBackground( Color.GREEN );
                PANEL_booting.setBackground(Color.GRAY);
                PANEL_checkingSums.setBackground(Color.GRAY);
                PANEL_erasingAndProgramming.setBackground(Color.GRAY);
                PANEL_sendingData.setBackground(Color.GRAY);
                PANEL_switchingToProgrammingMode.setBackground(Color.GRAY);
                JProgressBar_sendingData.setVisible(false);
                break;
        case SWITCHING_TO_PROGRAMMING_MODE:
                PANEL_idle.setBackground( Color.GRAY );
                PANEL_booting.setBackground(Color.GRAY);
                PANEL_checkingSums.setBackground(Color.GRAY);
                PANEL_erasingAndProgramming.setBackground(Color.GRAY);
                PANEL_sendingData.setBackground(Color.GRAY);
                PANEL_switchingToProgrammingMode.setBackground(Color.GREEN);
                JProgressBar_sendingData.setVisible(false);
                break;
        case SENDING_DATA:
                PANEL_idle.setBackground( Color.GRAY );
                PANEL_booting.setBackground(Color.GRAY);
                PANEL_checkingSums.setBackground(Color.GRAY);
                PANEL_erasingAndProgramming.setBackground(Color.GRAY);
                PANEL_sendingData.setBackground(Color.GREEN);
                PANEL_switchingToProgrammingMode.setBackground(Color.GRAY);
                JProgressBar_sendingData.setVisible(true);
                break;
        case REPROGRAMMING:
                PANEL_idle.setBackground( Color.GRAY );
                PANEL_booting.setBackground(Color.GRAY);
                PANEL_checkingSums.setBackground(Color.GRAY);
                PANEL_erasingAndProgramming.setBackground(Color.GREEN);
                PANEL_sendingData.setBackground(Color.GRAY);
                PANEL_switchingToProgrammingMode.setBackground(Color.GRAY);
                JProgressBar_sendingData.setVisible(false);
                break;                
        case CHECKING_CONTROL_SUMS:
                PANEL_idle.setBackground(Color.GRAY);
                PANEL_booting.setBackground(Color.GRAY);
                PANEL_checkingSums.setBackground(Color.GREEN);
                PANEL_erasingAndProgramming.setBackground(Color.GRAY);
                PANEL_sendingData.setBackground(Color.GRAY);
                PANEL_switchingToProgrammingMode.setBackground(Color.GRAY);
                JProgressBar_sendingData.setVisible(false);
                break;
        case BOOTING:
                PANEL_idle.setBackground( Color.GRAY );
                PANEL_booting.setBackground(Color.GREEN);
                PANEL_checkingSums.setBackground(Color.GRAY);
                PANEL_erasingAndProgramming.setBackground(Color.GRAY);
                PANEL_sendingData.setBackground(Color.GRAY);
                PANEL_switchingToProgrammingMode.setBackground(Color.GRAY);
                JProgressBar_sendingData.setVisible(false);
                break;
        default:
                PANEL_idle.setBackground( Color.GRAY );
                PANEL_booting.setBackground(Color.GRAY);
                PANEL_checkingSums.setBackground(Color.GRAY);
                PANEL_erasingAndProgramming.setBackground(Color.GRAY);
                PANEL_sendingData.setBackground(Color.GRAY);
                PANEL_switchingToProgrammingMode.setBackground(Color.GRAY);
                JProgressBar_sendingData.setVisible(false);
                break;
        }
        
        JLABEL_fileSum.setText("0x" + Integer.toHexString(status[1]).toUpperCase() );
        JLABEL_ramSum.setText("0x" + Integer.toHexString(status[2]).toUpperCase() );
        JLABEL_flashSum.setText( "0x"+ Integer.toHexString(status[3]).toUpperCase() );
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel20 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        PANEL_erasingAndProgramming = new javax.swing.JPanel();
        jLabel52 = new javax.swing.JLabel();
        PANEL_switchingToProgrammingMode = new javax.swing.JPanel();
        jLabel51 = new javax.swing.JLabel();
        PANEL_idle = new javax.swing.JPanel();
        jLabel58 = new javax.swing.JLabel();
        JBUTTON_reprogram = new javax.swing.JButton();
        PANEL_sendingData = new javax.swing.JPanel();
        jLabel50 = new javax.swing.JLabel();
        JProgressBar_sendingData = new javax.swing.JProgressBar();
        PANEL_checkingSums = new javax.swing.JPanel();
        jLabel53 = new javax.swing.JLabel();
        jLabel54 = new javax.swing.JLabel();
        JLABEL_fileSum = new javax.swing.JLabel();
        JLABEL_ramSum = new javax.swing.JLabel();
        jLabel55 = new javax.swing.JLabel();
        jLabel56 = new javax.swing.JLabel();
        JLABEL_flashSum = new javax.swing.JLabel();
        PANEL_booting = new javax.swing.JPanel();
        jLabel57 = new javax.swing.JLabel();
        jLabel49 = new javax.swing.JLabel();
        JTextField_fileName = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        JBUTTON_switchToProgrammingMode = new javax.swing.JButton();
        JBUTTON_sendData = new javax.swing.JButton();
        JBUTTON_earseAndReprogram = new javax.swing.JButton();
        JBUTTON_switchToMainProgram = new javax.swing.JButton();
        JBUTTON_checkControlSums = new javax.swing.JButton();

        jPanel20.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Flash programmer", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12))); // NOI18N

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Automatic", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        PANEL_erasingAndProgramming.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        javax.swing.GroupLayout PANEL_erasingAndProgrammingLayout = new javax.swing.GroupLayout(PANEL_erasingAndProgramming);
        PANEL_erasingAndProgramming.setLayout(PANEL_erasingAndProgrammingLayout);
        PANEL_erasingAndProgrammingLayout.setHorizontalGroup(
            PANEL_erasingAndProgrammingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 11, Short.MAX_VALUE)
        );
        PANEL_erasingAndProgrammingLayout.setVerticalGroup(
            PANEL_erasingAndProgrammingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 8, Short.MAX_VALUE)
        );

        jLabel52.setText("Erasing and programming");

        PANEL_switchingToProgrammingMode.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        javax.swing.GroupLayout PANEL_switchingToProgrammingModeLayout = new javax.swing.GroupLayout(PANEL_switchingToProgrammingMode);
        PANEL_switchingToProgrammingMode.setLayout(PANEL_switchingToProgrammingModeLayout);
        PANEL_switchingToProgrammingModeLayout.setHorizontalGroup(
            PANEL_switchingToProgrammingModeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 11, Short.MAX_VALUE)
        );
        PANEL_switchingToProgrammingModeLayout.setVerticalGroup(
            PANEL_switchingToProgrammingModeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 8, Short.MAX_VALUE)
        );

        jLabel51.setText("Switching to programming mode");

        PANEL_idle.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        javax.swing.GroupLayout PANEL_idleLayout = new javax.swing.GroupLayout(PANEL_idle);
        PANEL_idle.setLayout(PANEL_idleLayout);
        PANEL_idleLayout.setHorizontalGroup(
            PANEL_idleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 11, Short.MAX_VALUE)
        );
        PANEL_idleLayout.setVerticalGroup(
            PANEL_idleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 8, Short.MAX_VALUE)
        );

        jLabel58.setText("Idle");

        JBUTTON_reprogram.setText("Start programming");
        JBUTTON_reprogram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBUTTON_reprogramActionPerformed(evt);
            }
        });

        PANEL_sendingData.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        javax.swing.GroupLayout PANEL_sendingDataLayout = new javax.swing.GroupLayout(PANEL_sendingData);
        PANEL_sendingData.setLayout(PANEL_sendingDataLayout);
        PANEL_sendingDataLayout.setHorizontalGroup(
            PANEL_sendingDataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 11, Short.MAX_VALUE)
        );
        PANEL_sendingDataLayout.setVerticalGroup(
            PANEL_sendingDataLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 8, Short.MAX_VALUE)
        );

        jLabel50.setText("Sending data");

        JProgressBar_sendingData.setForeground(new java.awt.Color(102, 0, 102));
        JProgressBar_sendingData.setStringPainted(true);

        PANEL_checkingSums.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        javax.swing.GroupLayout PANEL_checkingSumsLayout = new javax.swing.GroupLayout(PANEL_checkingSums);
        PANEL_checkingSums.setLayout(PANEL_checkingSumsLayout);
        PANEL_checkingSumsLayout.setHorizontalGroup(
            PANEL_checkingSumsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 11, Short.MAX_VALUE)
        );
        PANEL_checkingSumsLayout.setVerticalGroup(
            PANEL_checkingSumsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 8, Short.MAX_VALUE)
        );

        jLabel53.setText("Checking control sums");

        jLabel54.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel54.setText("File");
        jLabel54.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        JLABEL_fileSum.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLABEL_fileSum.setText("0x00");
        JLABEL_fileSum.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLABEL_fileSum.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        JLABEL_ramSum.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLABEL_ramSum.setText("0x00");
        JLABEL_ramSum.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLABEL_ramSum.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel55.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel55.setText("RAM");
        jLabel55.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel56.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel56.setText("FLASH");
        jLabel56.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        JLABEL_flashSum.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLABEL_flashSum.setText("0x00");
        JLABEL_flashSum.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLABEL_flashSum.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        PANEL_booting.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        javax.swing.GroupLayout PANEL_bootingLayout = new javax.swing.GroupLayout(PANEL_booting);
        PANEL_booting.setLayout(PANEL_bootingLayout);
        PANEL_bootingLayout.setHorizontalGroup(
            PANEL_bootingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 11, Short.MAX_VALUE)
        );
        PANEL_bootingLayout.setVerticalGroup(
            PANEL_bootingLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 8, Short.MAX_VALUE)
        );

        jLabel57.setText("Booting programmed code");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(PANEL_erasingAndProgramming, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel52))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(PANEL_switchingToProgrammingMode, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel51))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(PANEL_idle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel58)
                                .addGap(18, 18, 18)
                                .addComponent(JBUTTON_reprogram))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(PANEL_sendingData, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(jLabel50)
                                .addGap(18, 18, 18)
                                .addComponent(JProgressBar_sendingData, javax.swing.GroupLayout.DEFAULT_SIZE, 361, Short.MAX_VALUE))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(PANEL_checkingSums, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel53)
                                .addGap(18, 18, 18)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jLabel54, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(JLABEL_fileSum, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(38, 38, 38)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(JLABEL_ramSum, javax.swing.GroupLayout.PREFERRED_SIZE, 73, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(jLabel55, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(23, 23, 23)
                                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jLabel56, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(JLABEL_flashSum, javax.swing.GroupLayout.PREFERRED_SIZE, 76, javax.swing.GroupLayout.PREFERRED_SIZE))))
                        .addContainerGap())
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(PANEL_booting, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel57)
                        .addContainerGap(333, Short.MAX_VALUE))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(PANEL_idle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel58)
                        .addComponent(JBUTTON_reprogram)))
                .addGap(29, 29, 29)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(PANEL_switchingToProgrammingMode, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel51))
                .addGap(27, 27, 27)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel50)
                        .addComponent(JProgressBar_sendingData, javax.swing.GroupLayout.PREFERRED_SIZE, 15, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(PANEL_sendingData, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(30, 30, 30)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(PANEL_erasingAndProgramming, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel52, javax.swing.GroupLayout.Alignment.TRAILING))
                        .addGap(32, 32, 32)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel53)
                            .addComponent(PANEL_checkingSums, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel54)
                            .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(jLabel56)
                                .addComponent(jLabel55)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(JLABEL_fileSum)
                            .addComponent(JLABEL_flashSum)
                            .addComponent(JLABEL_ramSum))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 31, Short.MAX_VALUE)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(PANEL_booting, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel57))
                .addContainerGap())
        );

        jLabel49.setText("Motorola S-hex file name:");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Manual", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        JBUTTON_switchToProgrammingMode.setText("Switch to programming mode");
        JBUTTON_switchToProgrammingMode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBUTTON_switchToProgrammingModeActionPerformed(evt);
            }
        });

        JBUTTON_sendData.setText("Send data");
        JBUTTON_sendData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBUTTON_sendDataActionPerformed(evt);
            }
        });

        JBUTTON_earseAndReprogram.setText("Erase and reprogram");
        JBUTTON_earseAndReprogram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBUTTON_earseAndReprogramActionPerformed(evt);
            }
        });

        JBUTTON_switchToMainProgram.setText("Switch to main program");
        JBUTTON_switchToMainProgram.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBUTTON_switchToMainProgramActionPerformed(evt);
            }
        });

        JBUTTON_checkControlSums.setText("Check control sums");
        JBUTTON_checkControlSums.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBUTTON_checkControlSumsActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JBUTTON_switchToProgrammingMode, javax.swing.GroupLayout.DEFAULT_SIZE, 249, Short.MAX_VALUE)
                    .addComponent(JBUTTON_checkControlSums, javax.swing.GroupLayout.DEFAULT_SIZE, 249, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(JBUTTON_sendData)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JBUTTON_earseAndReprogram, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                    .addComponent(JBUTTON_switchToMainProgram, javax.swing.GroupLayout.DEFAULT_SIZE, 224, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JBUTTON_switchToProgrammingMode)
                    .addComponent(JBUTTON_sendData)
                    .addComponent(JBUTTON_earseAndReprogram))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JBUTTON_switchToMainProgram)
                    .addComponent(JBUTTON_checkControlSums))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout jPanel20Layout = new javax.swing.GroupLayout(jPanel20);
        jPanel20.setLayout(jPanel20Layout);
        jPanel20Layout.setHorizontalGroup(
            jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel20Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel49)
                .addGap(17, 17, 17)
                .addComponent(JTextField_fileName, javax.swing.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE)
                .addContainerGap())
            .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel20Layout.setVerticalGroup(
            jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel20Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(jPanel20Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JTextField_fileName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel49))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel20, javax.swing.GroupLayout.PREFERRED_SIZE, 512, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(20, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel20, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(36, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    public void setDataSource( FlashProgrammer flashProgrammer )
    {
       this.flashProgrammer = flashProgrammer;
    }

    private void JBUTTON_reprogramActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JBUTTON_reprogramActionPerformed
    {//GEN-HEADEREND:event_JBUTTON_reprogramActionPerformed
        flashProgrammer.setFileName(JTextField_fileName.getText().trim());
        flashProgrammer.start();
}//GEN-LAST:event_JBUTTON_reprogramActionPerformed

    private void JBUTTON_switchToProgrammingModeActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JBUTTON_switchToProgrammingModeActionPerformed
    {//GEN-HEADEREND:event_JBUTTON_switchToProgrammingModeActionPerformed
        flashProgrammer.switchToProgrammingMode();
    }//GEN-LAST:event_JBUTTON_switchToProgrammingModeActionPerformed

    private void JBUTTON_sendDataActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JBUTTON_sendDataActionPerformed
    {//GEN-HEADEREND:event_JBUTTON_sendDataActionPerformed
       flashProgrammer.sendData(JTextField_fileName.getText().trim());
    }//GEN-LAST:event_JBUTTON_sendDataActionPerformed

    private void JBUTTON_earseAndReprogramActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JBUTTON_earseAndReprogramActionPerformed
    {//GEN-HEADEREND:event_JBUTTON_earseAndReprogramActionPerformed
        flashProgrammer.eraseAndReprogram();
    }//GEN-LAST:event_JBUTTON_earseAndReprogramActionPerformed

    private void JBUTTON_switchToMainProgramActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JBUTTON_switchToMainProgramActionPerformed
    {//GEN-HEADEREND:event_JBUTTON_switchToMainProgramActionPerformed
        flashProgrammer.switchToMainProgram();
    }//GEN-LAST:event_JBUTTON_switchToMainProgramActionPerformed

    private void JBUTTON_checkControlSumsActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JBUTTON_checkControlSumsActionPerformed
    {//GEN-HEADEREND:event_JBUTTON_checkControlSumsActionPerformed
        int[] sums = new int[2];
        flashProgrammer.requestControlSums(sums);
        JLABEL_ramSum.setText("0x"+Integer.toHexString(sums[0]));
        JLABEL_flashSum.setText("0x"+Integer.toHexString(sums[1]));
}//GEN-LAST:event_JBUTTON_checkControlSumsActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JButton JBUTTON_checkControlSums;
    public javax.swing.JButton JBUTTON_earseAndReprogram;
    public javax.swing.JButton JBUTTON_reprogram;
    public javax.swing.JButton JBUTTON_sendData;
    public javax.swing.JButton JBUTTON_switchToMainProgram;
    public javax.swing.JButton JBUTTON_switchToProgrammingMode;
    public javax.swing.JLabel JLABEL_fileSum;
    public javax.swing.JLabel JLABEL_flashSum;
    public javax.swing.JLabel JLABEL_ramSum;
    public javax.swing.JProgressBar JProgressBar_sendingData;
    public javax.swing.JTextField JTextField_fileName;
    public javax.swing.JPanel PANEL_booting;
    public javax.swing.JPanel PANEL_checkingSums;
    public javax.swing.JPanel PANEL_erasingAndProgramming;
    public javax.swing.JPanel PANEL_idle;
    public javax.swing.JPanel PANEL_sendingData;
    public javax.swing.JPanel PANEL_switchingToProgrammingMode;
    public javax.swing.JLabel jLabel49;
    public javax.swing.JLabel jLabel50;
    public javax.swing.JLabel jLabel51;
    public javax.swing.JLabel jLabel52;
    public javax.swing.JLabel jLabel53;
    public javax.swing.JLabel jLabel54;
    public javax.swing.JLabel jLabel55;
    public javax.swing.JLabel jLabel56;
    public javax.swing.JLabel jLabel57;
    public javax.swing.JLabel jLabel58;
    public javax.swing.JPanel jPanel1;
    public javax.swing.JPanel jPanel2;
    public javax.swing.JPanel jPanel20;
    // End of variables declaration//GEN-END:variables

}
