/*
 * Node.java
 *
 * Created on 17 August 2007, 13:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ticomViewer;

import de.desy.tine.client.TLink;
import de.desy.tine.client.TLinkCallback;
import java.util.EventListener;
import java.util.Vector;
import javax.swing.event.EventListenerList;

/**
 *
 * @author karol
 */
public class Node implements TLinkCallback
{
    static int indent = 0;
    private String name;
    private Vector children;
   
    Node()
    { children = new Vector(); name = new String("noname"); }
    Node( String name)
    { children = new Vector();  this.name  = new String(name); }
    public void setName(String name)
    { this.name = name; }
    public String getName()
    { return name;}
    @Override
    public String toString()
    { return name; }
    public void add(Node n)
    { children.add(n); }
    public void remove(Node n)
    { if( n != null ) children.remove(n); }    
    public Node getChild(int index)
    { return (Node)children.get(index); }
    public boolean isLeaf()
    { return (children.size() == 0); }
    public int getChildCount()
    { return children.size(); }
    
     public void addNodeChangedListener(NodeChangedListener l)
    {
        listenerList.add(NodeChangedListener.class, l);
    }
    
    public void removeNodeChangedListener(NodeChangedListener l)
    {
        listenerList.remove(NodeChangedListener.class, l);
    }
      
    protected void fireNodeChanged(NodeChangedEvent e)
    {
        EventListener[] listeners = listenerList.getListeners(NodeChangedListener.class);
        for(int i = 0; i < listeners.length; i++ ) ((NodeChangedListener)listeners[i]).nodeChanged(e);
    }
    
    private void fireNodesChanged(NodeChangedEvent e)
    {
        EventListener[] listeners = listenerList.getListeners(NodeChangedListener.class);
        for(int i = 0; i < listeners.length; i++ ) ((NodeChangedListener)listeners[i]).nodeChanged(e);
    }
    
    private EventListenerList listenerList = new EventListenerList();
    
    
    public void dump()
    {
        String s = new String();
        for( int i = 0; i < indent; i++ ) s+= " ";
        System.out.println( s + "Node = " + name);
        indent  += 3;
        int n = getChildCount();
        for( int i = 0; i < n; i++ ) getChild(i).dump();
        indent -= 3;
    }
    
    public void showControlPanel()
    {
        System.out.println("class Node, showing control panel");
    }
    
    @Override
    public void callback(TLink link)
    {
        System.out.println( "Node: " + name + " link = " + link.getFullDeviceName()
        + " activated, status =" + link.getLinkStatus());
    }
}

