/*
 * TPDOvariablesTableModel.java
 *
 * Created on 17 August 2007, 13:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ticomViewer;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author karol
 */
public class TPDOvariablesTableModel extends AbstractTableModel
{
    private PlotPanel[] plotPanel;
    private PdoMappedVariable[] pmv;
    private Mbutton[] button;
    private CanNodeDevice owner;
    
    @Override
    public boolean isCellEditable(int rowIndex, int colIndex) 
    {
        return colIndex == 3;
    }
    public JButton[] getButtons() 
    {
        return button;
    }
    public TPDOvariablesTableModel(CanNodeDevice owner, PdoMappedVariable pmv[])
    {
        this.pmv = pmv;
        this.owner = owner;
        button = new Mbutton[pmv.length];
        plotPanel = new PlotPanel[pmv.length];
        final TPDOvariablesTableModel windowCreator = this;
        
        for(int i = 0; i < button.length; i++ ) 
        {
            String caption = "show";           
            //String connection = TicomView.TicomViewer.getServerPath()+"/"+ owner.getName() +"/"+ pmv[i].variableName.toString().trim();
            PlotPanel.deviceSelection ds = new PlotPanel.deviceSelection(TicomView.TicomViewer.getServerPath()+"/"+ owner.getName(),pmv[i]);
           
            button[i] = new Mbutton(caption, i, ds );                   
            button[i].addActionListener( new ActionListener()
            {
                public void actionPerformed(ActionEvent e)
                {
                    Mbutton b = (Mbutton)(e.getSource());
                    int i = b.getIndex();
                    if( plotPanel[i] == null )
                    {
                        PlotPanel.deviceSelection ds  = (PlotPanel.deviceSelection)b.getObject();
                        System.out.println(" Opening plot for connection: " + ds.getServerPath()+"/"+ds.getV().variableName);
                        plotPanel[i] = new PlotPanel(windowCreator,ds);
                        plotPanel[i].setVisible(true);
                        b.setText("hide");                        
                    }
                    else
                    {
                        plotPanel[i].dispose();
                        plotPanel[i] = null;
                        b.setText("show");                       
                    }
                }
            });
        }
    }
    
    public void plotClosed(PlotPanel p)
    {
       for( int i = 0; i < plotPanel.length; i++) 
       {
           if( p.equals(plotPanel[i]))
           {
               plotPanel[i] = null;
               button[i].setText("show");   
           }               
       }       
    }
    
    public void rowChanged( int row )
    { 
        fireTableRowsUpdated(row,row);
    }
    public int getRowCount()
    {
        for( int i = 0; i < pmv.length; i++ ) if( pmv[i].index[0] == 0  ) return i;
        return pmv.length;
    }
    public int getColumnCount()
    {
        return 4;
    }
    public Object getValueAt(int rowIndex, int columnIndex)
    {
        switch( columnIndex )
        {
            case 0: return pmv[rowIndex].variableName.toString();
            case 1: return CanData.bytesArrayToLong( pmv[rowIndex].dataValue );
            case 2: return CanNodeDevice.getTimeStamp(CanData.bytesArrayToLong(pmv[rowIndex].updateTime));
            case 3: return button[rowIndex];
        }
        return null;
    }
    private String ColumnHeaders[] = {"Variable", "Value", "Update time", "Plot" };
    public String getColumnName(int columnNo)
    {
        return ColumnHeaders[columnNo];
    }      
}

