/*
 * TicomView.java
 *
 * Created on 18 June 2007, 14:27
 */

package ticomViewer;

import de.desy.tine.client.TLink;
import de.desy.tine.client.TLinkCallback;
import de.desy.tine.dataUtils.TDataType;
import de.desy.tine.definitions.TAccess;
import de.desy.tine.definitions.TErrorList;
import de.desy.tine.definitions.TMode;
import de.desy.tine.queryUtils.TQuery;
import de.desy.tine.structUtils.TTaggedStructure;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Arrays;
import javax.swing.JPanel;
import javax.swing.UIManager;
import javax.swing.tree.TreePath;



/**
 *
 * @author  karol
 */


public class TicomView extends javax.swing.JFrame
{
    
    private final String VERSION = "1.3" ;
    
    private CanopenBusTreeModel canopenBusTreeModel = new CanopenBusTreeModel();
    private BusInfo  BusInfoData = new BusInfo();
    private TLink SyncInfoLink;
    private TLink TimeProducerInfoLink;
    private TLink busInfoLink;
    private CanNodeDevice currentlySelectedCanNodeDevice;
    private String serverPath = new String("");
    public EmcyDisplay EmcyLog;
    private FlashProgrammerDisplayer flashProgrammerDisplayer;
    
    /** Creates new form TicomView */
    public TicomView()
    {
        initComponents();
        initControls(); 
        setTitle( "TICOM Viewer, version: " + VERSION);
        
        // tree
        BusNodeTreeCellRenderer renderer = new BusNodeTreeCellRenderer();
        JTree_CanBus.setModel(canopenBusTreeModel);
        JTree_CanBus.setCellRenderer(renderer);
        JTree_CanBus.setRowHeight(35);   
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSplitPane1 = new javax.swing.JSplitPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        JTree_CanBus = new javax.swing.JTree();
        JPanel_infoPanel = new javax.swing.JPanel();
        JPanel_busControl = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        jLabel16 = new javax.swing.JLabel();
        JLabel_ticomVersion = new javax.swing.JLabel();
        JLabel_ticomStartTime = new javax.swing.JLabel();
        JLabel_numberOfNodes = new javax.swing.JLabel();
        jLabel20 = new javax.swing.JLabel();
        jLabel21 = new javax.swing.JLabel();
        JLabel_busSpeed = new javax.swing.JLabel();
        jLabel17 = new javax.swing.JLabel();
        JPanel_canNodeControl = new javax.swing.JPanel();
        JTabbedPane_nodeControl = new javax.swing.JTabbedPane();
        jPanel7 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jLabel18 = new javax.swing.JLabel();
        JLabel_nodeName = new javax.swing.JLabel();
        jLabel34 = new javax.swing.JLabel();
        JLabel_manufactureDeviceName = new javax.swing.JLabel();
        JLabel_deviceType = new javax.swing.JLabel();
        jLabel29 = new javax.swing.JLabel();
        jLabel27 = new javax.swing.JLabel();
        JLabel_hardwareVersion = new javax.swing.JLabel();
        JLabel_softwareVersion = new javax.swing.JLabel();
        jLabel28 = new javax.swing.JLabel();
        jLabel30 = new javax.swing.JLabel();
        JLabel_vendorId = new javax.swing.JLabel();
        jLabel31 = new javax.swing.JLabel();
        JLabel_productCode = new javax.swing.JLabel();
        jLabel32 = new javax.swing.JLabel();
        JLabel_revisionNumber = new javax.swing.JLabel();
        jLabel33 = new javax.swing.JLabel();
        JLabel_serialNumber = new javax.swing.JLabel();
        JLabel_nodeId = new javax.swing.JLabel();
        JPanel_NMT = new javax.swing.JPanel();
        JLabel_resetCounter = new javax.swing.JLabel();
        JLabel_preOperationalCounter = new javax.swing.JLabel();
        JLabel_operationalCounter = new javax.swing.JLabel();
        JLabel_stoppedCounter = new javax.swing.JLabel();
        JButton_resetNode = new javax.swing.JButton();
        JButton_preoperationalNode = new javax.swing.JButton();
        JButton_operationalNode = new javax.swing.JButton();
        JButton_stopNode = new javax.swing.JButton();
        jLabel38 = new javax.swing.JLabel();
        jLabel39 = new javax.swing.JLabel();
        JLabel_resetEntryTime = new javax.swing.JLabel();
        JLabel_preoperationalEntryTime = new javax.swing.JLabel();
        JLabel_operationalEntryTime = new javax.swing.JLabel();
        JLabel_stopEntryTime = new javax.swing.JLabel();
        jLabel26 = new javax.swing.JLabel();
        JLabel_noHeartBeatTime = new javax.swing.JLabel();
        jPanel9 = new javax.swing.JPanel();
        jPanel10 = new javax.swing.JPanel();
        jLabel35 = new javax.swing.JLabel();
        jLabel36 = new javax.swing.JLabel();
        JLabel_heartbeatPeriod = new javax.swing.JLabel();
        JLabel_heartbeatEnabled = new javax.swing.JLabel();
        jLabel37 = new javax.swing.JLabel();
        jPanel11 = new javax.swing.JPanel();
        jLabel40 = new javax.swing.JLabel();
        jLabel41 = new javax.swing.JLabel();
        JCheckBox_heartbeat = new javax.swing.JCheckBox();
        JSlider_setHeartbeatPeriod = new javax.swing.JSlider();
        JText_heartbeatPeriod = new javax.swing.JTextField();
        JButton_setHeartbeatParameters = new javax.swing.JButton();
        jLabel42 = new javax.swing.JLabel();
        jPanel12 = new javax.swing.JPanel();
        jPanel13 = new javax.swing.JPanel();
        jLabel43 = new javax.swing.JLabel();
        jLabel44 = new javax.swing.JLabel();
        JText_index = new javax.swing.JTextField();
        JText_subindex = new javax.swing.JTextField();
        JBUTTON_sdoRead = new javax.swing.JButton();
        JLabel_odRead = new javax.swing.JLabel();
        JText_odWrite = new javax.swing.JTextField();
        JButton_sdoWrite = new javax.swing.JButton();
        JLabel_odReadStatus = new javax.swing.JLabel();
        jLabel45 = new javax.swing.JLabel();
        jPanel15 = new javax.swing.JPanel();
        jScrollPane3 = new javax.swing.JScrollPane();
        JTable_rPdoVariables = new javax.swing.JTable();
        jPanel14 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        JTable_tPdoVariables = new javax.swing.JTable();
        jPanel16 = new javax.swing.JPanel();
        jPanel17 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        JList_logWindow = new javax.swing.JList();
        JPanel_syncControl = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        JLabel_syncPeriod = new javax.swing.JLabel();
        JLabel_syncOnOff = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jPanel2 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        JCheckBox_syncProducerOn = new javax.swing.JCheckBox();
        JSlider_setSyncPeriod = new javax.swing.JSlider();
        JText_syncPeriod = new javax.swing.JTextField();
        JButton_setSyncParameters = new javax.swing.JButton();
        jLabel6 = new javax.swing.JLabel();
        JPanel_timeControl = new javax.swing.JPanel();
        jPanel3 = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        JLabel_timeProducerPeriod = new javax.swing.JLabel();
        JLabel_timeProducerOnOff = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        JLabel_milisecondsSinceMidnight = new javax.swing.JLabel();
        JLabel_daysSince1984 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        JCheckBox_timeProducerOn = new javax.swing.JCheckBox();
        JSlider_setTimeProducerPeriod = new javax.swing.JSlider();
        JText_timeProducerPeriod = new javax.swing.JTextField();
        JButton_setTimeProducerParameters = new javax.swing.JButton();
        jLabel13 = new javax.swing.JLabel();
        JPanel_devicesControl = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        JLabel_totalNumberOfnodes = new javax.swing.JLabel();
        jLabel22 = new javax.swing.JLabel();
        JLabel_totalInPreoperational = new javax.swing.JLabel();
        jLabel23 = new javax.swing.JLabel();
        JLabel_totalInOperational = new javax.swing.JLabel();
        jLabel24 = new javax.swing.JLabel();
        JLabel_totalInStopped = new javax.swing.JLabel();
        jLabel25 = new javax.swing.JLabel();
        JLabel_totalInUnknown = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        JButton_resetAll = new javax.swing.JButton();
        JButton_preoperationalAll = new javax.swing.JButton();
        JButton_operationalAll = new javax.swing.JButton();
        JButton_stopAll = new javax.swing.JButton();
        JTollbar_statusBar = new javax.swing.JToolBar();
        JLabel_Status1 = new javax.swing.JLabel();
        jPanel18 = new javax.swing.JPanel();
        jLabel46 = new javax.swing.JLabel();
        JComboBox_deviceContext = new javax.swing.JComboBox();
        jLabel48 = new javax.swing.JLabel();
        JComboBox_deviceSubsystem = new javax.swing.JComboBox();
        jLabel47 = new javax.swing.JLabel();
        JComboBox_deviceServer = new javax.swing.JComboBox();
        JButton_connect = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jSplitPane1.setDividerLocation(180);
        jSplitPane1.setDividerSize(10);
        jSplitPane1.setMaximumSize(new java.awt.Dimension(500, 2147483647));
        jSplitPane1.setRequestFocusEnabled(false);

        jScrollPane1.setMinimumSize(new java.awt.Dimension(150, 24));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(150, 324));

        JTree_CanBus.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                JTree_CanBusValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(JTree_CanBus);

        jSplitPane1.setLeftComponent(jScrollPane1);

        JPanel_infoPanel.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        JPanel_infoPanel.setLayout(new java.awt.CardLayout());

        JPanel_busControl.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        JPanel_busControl.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                JPanel_busControlComponentHidden(evt);
            }
            public void componentShown(java.awt.event.ComponentEvent evt) {
                JPanel_busControlComponentShown(evt);
            }
        });

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText("TICOM version:");
        jLabel3.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel16.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel16.setText("started:");
        jLabel16.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_ticomVersion.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_ticomVersion.setText(" ");
        JLabel_ticomVersion.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_ticomVersion.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_ticomVersion.setRequestFocusEnabled(false);

        JLabel_ticomStartTime.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_ticomStartTime.setText(" ");
        JLabel_ticomStartTime.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_ticomStartTime.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        JLabel_numberOfNodes.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_numberOfNodes.setText(" ");
        JLabel_numberOfNodes.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_numberOfNodes.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_numberOfNodes.setRequestFocusEnabled(false);

        jLabel20.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel20.setText("number of nodes:");
        jLabel20.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel21.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel21.setText("bus speed:");
        jLabel21.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_busSpeed.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_busSpeed.setText(" ");
        JLabel_busSpeed.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_busSpeed.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_busSpeed.setRequestFocusEnabled(false);

        jLabel17.setText("bits/sec");

        javax.swing.GroupLayout JPanel_busControlLayout = new javax.swing.GroupLayout(JPanel_busControl);
        JPanel_busControl.setLayout(JPanel_busControlLayout);
        JPanel_busControlLayout.setHorizontalGroup(
            JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_busControlLayout.createSequentialGroup()
                .addGap(23, 23, 23)
                .addGroup(JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                        .addGroup(JPanel_busControlLayout.createSequentialGroup()
                            .addComponent(jLabel20, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(JLabel_numberOfNodes, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGap(127, 127, 127))
                        .addGroup(JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(JPanel_busControlLayout.createSequentialGroup()
                                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(JLabel_ticomVersion, javax.swing.GroupLayout.PREFERRED_SIZE, 188, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(JPanel_busControlLayout.createSequentialGroup()
                                .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(JLabel_ticomStartTime, javax.swing.GroupLayout.PREFERRED_SIZE, 188, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(JPanel_busControlLayout.createSequentialGroup()
                        .addComponent(jLabel21, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JLabel_busSpeed, javax.swing.GroupLayout.PREFERRED_SIZE, 61, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel17)))
                .addContainerGap(403, Short.MAX_VALUE))
        );
        JPanel_busControlLayout.setVerticalGroup(
            JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_busControlLayout.createSequentialGroup()
                .addGap(20, 20, 20)
                .addGroup(JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(JLabel_ticomVersion))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel16, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_ticomStartTime))
                .addGap(41, 41, 41)
                .addGroup(JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel20, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_numberOfNodes))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(JPanel_busControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel21, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_busSpeed)
                    .addComponent(jLabel17))
                .addContainerGap(450, Short.MAX_VALUE))
        );

        JPanel_infoPanel.add(JPanel_busControl, "card2");

        JPanel_canNodeControl.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jPanel8.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Node identification data", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 12))); // NOI18N

        jLabel18.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel18.setText("Node:");
        jLabel18.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_nodeName.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_nodeName.setText(" ");
        JLabel_nodeName.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_nodeName.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_nodeName.setRequestFocusEnabled(false);

        jLabel34.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel34.setText("Manufacturer device name:");
        jLabel34.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_manufactureDeviceName.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_manufactureDeviceName.setText(" ");
        JLabel_manufactureDeviceName.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_manufactureDeviceName.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_manufactureDeviceName.setRequestFocusEnabled(false);

        JLabel_deviceType.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_deviceType.setText(" ");
        JLabel_deviceType.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_deviceType.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_deviceType.setRequestFocusEnabled(false);

        jLabel29.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel29.setText("Device type:");
        jLabel29.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel27.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel27.setText("Hardware version:");
        jLabel27.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_hardwareVersion.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_hardwareVersion.setText(" ");
        JLabel_hardwareVersion.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_hardwareVersion.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_hardwareVersion.setRequestFocusEnabled(false);

        JLabel_softwareVersion.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_softwareVersion.setText(" ");
        JLabel_softwareVersion.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_softwareVersion.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_softwareVersion.setRequestFocusEnabled(false);

        jLabel28.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel28.setText("Software version:");
        jLabel28.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel30.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel30.setText("Vendor ID:");
        jLabel30.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_vendorId.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_vendorId.setText(" ");
        JLabel_vendorId.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_vendorId.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_vendorId.setRequestFocusEnabled(false);

        jLabel31.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel31.setText("Product code:");
        jLabel31.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_productCode.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_productCode.setText(" ");
        JLabel_productCode.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_productCode.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_productCode.setRequestFocusEnabled(false);

        jLabel32.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        jLabel32.setText("Revision number:");
        jLabel32.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_revisionNumber.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_revisionNumber.setText(" ");
        JLabel_revisionNumber.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_revisionNumber.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_revisionNumber.setRequestFocusEnabled(false);

        jLabel33.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel33.setText("Serial number:");
        jLabel33.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_serialNumber.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_serialNumber.setText(" ");
        JLabel_serialNumber.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_serialNumber.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_serialNumber.setRequestFocusEnabled(false);

        JLabel_nodeId.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_nodeId.setText(" ");
        JLabel_nodeId.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_nodeId.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_nodeId.setRequestFocusEnabled(false);

        javax.swing.GroupLayout jPanel8Layout = new javax.swing.GroupLayout(jPanel8);
        jPanel8.setLayout(jPanel8Layout);
        jPanel8Layout.setHorizontalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel27, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel29, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel18, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel34, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel33, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel32, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel31, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel30, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel28, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel8Layout.createSequentialGroup()
                                .addComponent(JLabel_nodeId, javax.swing.GroupLayout.PREFERRED_SIZE, 111, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(JLabel_nodeName, javax.swing.GroupLayout.PREFERRED_SIZE, 283, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(JLabel_deviceType, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE)
                            .addComponent(JLabel_hardwareVersion, javax.swing.GroupLayout.DEFAULT_SIZE, 400, Short.MAX_VALUE))
                        .addGap(55, 55, 55))
                    .addGroup(jPanel8Layout.createSequentialGroup()
                        .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(JLabel_manufactureDeviceName, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
                            .addComponent(JLabel_serialNumber, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
                            .addComponent(JLabel_productCode, javax.swing.GroupLayout.DEFAULT_SIZE, 250, Short.MAX_VALUE)
                            .addComponent(JLabel_vendorId, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(JLabel_revisionNumber, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(JLabel_softwareVersion, javax.swing.GroupLayout.PREFERRED_SIZE, 401, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap())))
        );
        jPanel8Layout.setVerticalGroup(
            jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel8Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel18)
                        .addComponent(JLabel_nodeId, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(JLabel_nodeName, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel29, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_deviceType, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel27, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_hardwareVersion, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel28, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_softwareVersion, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel30, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_vendorId, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLabel_productCode, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel31, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel32)
                    .addComponent(JLabel_revisionNumber, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLabel_serialNumber, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel33, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(4, 4, 4)
                .addGroup(jPanel8Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel34, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_manufactureDeviceName, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        JPanel_NMT.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "NMT", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 12))); // NOI18N

        JLabel_resetCounter.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        JLabel_resetCounter.setText("0");
        JLabel_resetCounter.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        JLabel_preOperationalCounter.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        JLabel_preOperationalCounter.setText("0");
        JLabel_preOperationalCounter.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        JLabel_operationalCounter.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        JLabel_operationalCounter.setText("0");
        JLabel_operationalCounter.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        JLabel_stoppedCounter.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        JLabel_stoppedCounter.setText("0");
        JLabel_stoppedCounter.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        JButton_resetNode.setText("Reset");
        JButton_resetNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_resetNodeActionPerformed(evt);
            }
        });

        JButton_preoperationalNode.setText("Preoperational");
        JButton_preoperationalNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_preoperationalNodeActionPerformed(evt);
            }
        });

        JButton_operationalNode.setText("Operational");
        JButton_operationalNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_operationalNodeActionPerformed(evt);
            }
        });

        JButton_stopNode.setText("Stop");
        JButton_stopNode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_stopNodeActionPerformed(evt);
            }
        });

        jLabel38.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel38.setText("Counters");
        jLabel38.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel39.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel39.setText("Timestamp");
        jLabel39.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        JLabel_resetEntryTime.setBackground(new java.awt.Color(153, 153, 153));
        JLabel_resetEntryTime.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_resetEntryTime.setText("23.07.2007, 01:23:24");
        JLabel_resetEntryTime.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_resetEntryTime.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_resetEntryTime.setOpaque(true);

        JLabel_preoperationalEntryTime.setBackground(new java.awt.Color(255, 255, 0));
        JLabel_preoperationalEntryTime.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_preoperationalEntryTime.setText("23.07.2007, 01:23:24");
        JLabel_preoperationalEntryTime.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_preoperationalEntryTime.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_preoperationalEntryTime.setOpaque(true);

        JLabel_operationalEntryTime.setBackground(new java.awt.Color(51, 255, 0));
        JLabel_operationalEntryTime.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_operationalEntryTime.setText("23.07.2007, 01:23:24");
        JLabel_operationalEntryTime.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_operationalEntryTime.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_operationalEntryTime.setOpaque(true);

        JLabel_stopEntryTime.setBackground(new java.awt.Color(255, 51, 51));
        JLabel_stopEntryTime.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_stopEntryTime.setText("23.07.2007, 01:23:24");
        JLabel_stopEntryTime.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_stopEntryTime.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_stopEntryTime.setOpaque(true);

        jLabel26.setText("No heartbeat:");

        JLabel_noHeartBeatTime.setBackground(new java.awt.Color(255, 102, 255));
        JLabel_noHeartBeatTime.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_noHeartBeatTime.setText("23.07.2007, 01:23:24");
        JLabel_noHeartBeatTime.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_noHeartBeatTime.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_noHeartBeatTime.setOpaque(true);

        javax.swing.GroupLayout JPanel_NMTLayout = new javax.swing.GroupLayout(JPanel_NMT);
        JPanel_NMT.setLayout(JPanel_NMTLayout);
        JPanel_NMTLayout.setHorizontalGroup(
            JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, JPanel_NMTLayout.createSequentialGroup()
                .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel38)
                    .addComponent(JLabel_stoppedCounter, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE)
                    .addComponent(JLabel_resetCounter, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE)
                    .addComponent(JLabel_preOperationalCounter, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE)
                    .addComponent(JLabel_operationalCounter, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 68, Short.MAX_VALUE)
                    .addComponent(jLabel26))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JLabel_noHeartBeatTime, javax.swing.GroupLayout.DEFAULT_SIZE, 127, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(JLabel_stopEntryTime, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(JLabel_operationalEntryTime, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(JLabel_preoperationalEntryTime, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(JLabel_resetEntryTime, javax.swing.GroupLayout.DEFAULT_SIZE, 127, Short.MAX_VALUE)
                        .addComponent(jLabel39, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(JButton_stopNode, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(JButton_preoperationalNode, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(JButton_operationalNode, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(JButton_resetNode, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        JPanel_NMTLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {JLabel_operationalEntryTime, JLabel_preoperationalEntryTime, JLabel_resetEntryTime, JLabel_stopEntryTime});

        JPanel_NMTLayout.setVerticalGroup(
            JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_NMTLayout.createSequentialGroup()
                .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(JPanel_NMTLayout.createSequentialGroup()
                        .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel38)
                            .addComponent(jLabel39))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                .addComponent(JLabel_resetEntryTime, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(JButton_resetNode))
                            .addComponent(JLabel_resetCounter, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(2, 2, 2)
                        .addComponent(JLabel_preOperationalCounter, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(8, 8, 8)
                        .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(JLabel_operationalEntryTime, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(JButton_operationalNode)
                            .addComponent(JLabel_operationalCounter, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(JLabel_stoppedCounter, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(JLabel_stopEntryTime, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(JButton_stopNode)))
                    .addGroup(JPanel_NMTLayout.createSequentialGroup()
                        .addGap(46, 46, 46)
                        .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(JLabel_preoperationalEntryTime, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(JButton_preoperationalNode))))
                .addGap(32, 32, 32)
                .addGroup(JPanel_NMTLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel26)
                    .addComponent(JLabel_noHeartBeatTime, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        JPanel_NMTLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {JLabel_operationalCounter, JLabel_preOperationalCounter, JLabel_resetCounter, JLabel_stoppedCounter});

        JPanel_NMTLayout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {JLabel_operationalEntryTime, JLabel_preoperationalEntryTime, JLabel_resetEntryTime, JLabel_stopEntryTime});

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Heartbeat control", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 12))); // NOI18N

        jPanel10.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Current settings", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 10))); // NOI18N

        jLabel35.setFont(new java.awt.Font("Arial", 0, 10));
        jLabel35.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel35.setText("period: ");
        jLabel35.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel36.setFont(new java.awt.Font("Arial", 0, 10));
        jLabel36.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel36.setText("enabled:");
        jLabel36.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_heartbeatPeriod.setFont(new java.awt.Font("Arial", 0, 10));
        JLabel_heartbeatPeriod.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_heartbeatPeriod.setText("0");
        JLabel_heartbeatPeriod.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_heartbeatPeriod.setRequestFocusEnabled(false);

        JLabel_heartbeatEnabled.setFont(new java.awt.Font("Arial", 0, 10));
        JLabel_heartbeatEnabled.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_heartbeatEnabled.setText("YES");
        JLabel_heartbeatEnabled.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_heartbeatEnabled.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_heartbeatEnabled.setRequestFocusEnabled(false);

        jLabel37.setText("ms");

        javax.swing.GroupLayout jPanel10Layout = new javax.swing.GroupLayout(jPanel10);
        jPanel10.setLayout(jPanel10Layout);
        jPanel10Layout.setHorizontalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel36)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JLabel_heartbeatEnabled, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel35, javax.swing.GroupLayout.PREFERRED_SIZE, 44, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JLabel_heartbeatPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel37)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel10Layout.setVerticalGroup(
            jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel10Layout.createSequentialGroup()
                .addGroup(jPanel10Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel36)
                    .addComponent(JLabel_heartbeatEnabled)
                    .addComponent(jLabel35)
                    .addComponent(JLabel_heartbeatPeriod)
                    .addComponent(jLabel37))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel11.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Set", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 10))); // NOI18N
        jPanel11.setFont(new java.awt.Font("Arial", 0, 10));

        jLabel40.setFont(new java.awt.Font("Arial", 0, 10));
        jLabel40.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel40.setText("period:");
        jLabel40.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel41.setFont(new java.awt.Font("Arial", 0, 10));
        jLabel41.setText("ms");

        JCheckBox_heartbeat.setFont(new java.awt.Font("Arial", 0, 12));
        JCheckBox_heartbeat.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        JCheckBox_heartbeat.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JCheckBox_heartbeat.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        JCheckBox_heartbeat.setMargin(new java.awt.Insets(0, 0, 0, 0));

        JSlider_setHeartbeatPeriod.setFont(new java.awt.Font("Arial", 0, 10));
        JSlider_setHeartbeatPeriod.setMajorTickSpacing(500);
        JSlider_setHeartbeatPeriod.setMaximum(2500);
        JSlider_setHeartbeatPeriod.setMinorTickSpacing(100);
        JSlider_setHeartbeatPeriod.setPaintLabels(true);
        JSlider_setHeartbeatPeriod.setPaintTicks(true);
        JSlider_setHeartbeatPeriod.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                JSlider_setHeartbeatPeriodStateChanged(evt);
            }
        });

        JText_heartbeatPeriod.setColumns(5);
        JText_heartbeatPeriod.setFont(new java.awt.Font("Arial", 0, 10));
        JText_heartbeatPeriod.setText("0");
        JText_heartbeatPeriod.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                JText_heartbeatPeriodFocusLost(evt);
            }
        });
        JText_heartbeatPeriod.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                JText_heartbeatPeriodKeyPressed(evt);
            }
        });

        JButton_setHeartbeatParameters.setText("Set");
        JButton_setHeartbeatParameters.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JButton_setHeartbeatParameters.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_setHeartbeatParametersActionPerformed(evt);
            }
        });

        jLabel42.setFont(new java.awt.Font("Arial", 0, 10));
        jLabel42.setText("Enable:");
        jLabel42.setRequestFocusEnabled(false);

        javax.swing.GroupLayout jPanel11Layout = new javax.swing.GroupLayout(jPanel11);
        jPanel11.setLayout(jPanel11Layout);
        jPanel11Layout.setHorizontalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel11Layout.createSequentialGroup()
                            .addContainerGap()
                            .addComponent(jLabel42)
                            .addGap(4, 4, 4)
                            .addComponent(JCheckBox_heartbeat)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(jLabel40, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(JText_heartbeatPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel41)
                            .addGap(14, 14, 14))
                        .addComponent(JSlider_setHeartbeatPeriod, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 226, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel11Layout.createSequentialGroup()
                        .addGap(90, 90, 90)
                        .addComponent(JButton_setHeartbeatParameters)))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel11Layout.setVerticalGroup(
            jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel11Layout.createSequentialGroup()
                .addGroup(jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel42, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(JCheckBox_heartbeat, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel40, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel11Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(JText_heartbeatPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(jLabel41)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JSlider_setHeartbeatPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(JButton_setHeartbeatParameters))
        );

        javax.swing.GroupLayout jPanel9Layout = new javax.swing.GroupLayout(jPanel9);
        jPanel9.setLayout(jPanel9Layout);
        jPanel9Layout.setHorizontalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        jPanel9Layout.setVerticalGroup(
            jPanel9Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel9Layout.createSequentialGroup()
                .addComponent(jPanel10, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel11, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        javax.swing.GroupLayout jPanel7Layout = new javax.swing.GroupLayout(jPanel7);
        jPanel7.setLayout(jPanel7Layout);
        jPanel7Layout.setHorizontalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                .addComponent(jPanel8, javax.swing.GroupLayout.Alignment.LEADING, 0, 588, Short.MAX_VALUE)
                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel7Layout.createSequentialGroup()
                    .addComponent(JPanel_NMT, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(jPanel9, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        jPanel7Layout.setVerticalGroup(
            jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel7Layout.createSequentialGroup()
                .addComponent(jPanel8, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel7Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(JPanel_NMT, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel9, javax.swing.GroupLayout.DEFAULT_SIZE, 215, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        JTabbedPane_nodeControl.addTab("tab1", jPanel7);
        jPanel7.getAccessibleContext().setAccessibleParent(JTabbedPane_nodeControl);

        jPanel12.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jPanel13.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "OD access", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 12))); // NOI18N

        jLabel43.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel43.setText("Index:  0x");
        jLabel43.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel44.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel44.setText("Subindex: 0x");
        jLabel44.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JText_index.setText("1000");

        JText_subindex.setText("0");

        JBUTTON_sdoRead.setText("Read");
        JBUTTON_sdoRead.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JBUTTON_sdoReadActionPerformed(evt);
            }
        });

        JLabel_odRead.setBackground(new java.awt.Color(204, 204, 255));
        JLabel_odRead.setOpaque(true);

        JButton_sdoWrite.setText("Write");
        JButton_sdoWrite.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_sdoWriteActionPerformed(evt);
            }
        });

        JLabel_odReadStatus.setBackground(new java.awt.Color(255, 204, 204));
        JLabel_odReadStatus.setOpaque(true);

        jLabel45.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel45.setText("Status:");
        jLabel45.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        javax.swing.GroupLayout jPanel13Layout = new javax.swing.GroupLayout(jPanel13);
        jPanel13.setLayout(jPanel13Layout);
        jPanel13Layout.setHorizontalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel13Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel13Layout.createSequentialGroup()
                        .addComponent(jLabel45)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JLabel_odReadStatus, javax.swing.GroupLayout.DEFAULT_SIZE, 626, Short.MAX_VALUE))
                    .addGroup(jPanel13Layout.createSequentialGroup()
                        .addComponent(JText_odWrite, javax.swing.GroupLayout.DEFAULT_SIZE, 600, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JButton_sdoWrite))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel13Layout.createSequentialGroup()
                        .addComponent(jLabel43)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JText_index, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(20, 20, 20)
                        .addComponent(jLabel44, javax.swing.GroupLayout.PREFERRED_SIZE, 77, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JText_subindex, javax.swing.GroupLayout.PREFERRED_SIZE, 45, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel13Layout.createSequentialGroup()
                        .addComponent(JBUTTON_sdoRead)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JLabel_odRead, javax.swing.GroupLayout.DEFAULT_SIZE, 604, Short.MAX_VALUE)))
                .addContainerGap())
        );
        jPanel13Layout.setVerticalGroup(
            jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel13Layout.createSequentialGroup()
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel43)
                    .addComponent(JText_index, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel44)
                    .addComponent(JText_subindex, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(12, 12, 12)
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(JLabel_odRead, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JBUTTON_sdoRead))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JButton_sdoWrite)
                    .addComponent(JText_odWrite, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel13Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel45, javax.swing.GroupLayout.DEFAULT_SIZE, 23, Short.MAX_VALUE)
                    .addComponent(JLabel_odReadStatus, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jPanel15.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Read Process Variables (RPDO)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 12))); // NOI18N

        JTable_rPdoVariables.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane3.setViewportView(JTable_rPdoVariables);

        javax.swing.GroupLayout jPanel15Layout = new javax.swing.GroupLayout(jPanel15);
        jPanel15.setLayout(jPanel15Layout);
        jPanel15Layout.setHorizontalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 687, Short.MAX_VALUE)
        );
        jPanel15Layout.setVerticalGroup(
            jPanel15Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 130, Short.MAX_VALUE)
        );

        jPanel14.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Transmit Process Variables (TPDO)", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 12))); // NOI18N

        JTable_tPdoVariables.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane2.setViewportView(JTable_tPdoVariables);

        javax.swing.GroupLayout jPanel14Layout = new javax.swing.GroupLayout(jPanel14);
        jPanel14.setLayout(jPanel14Layout);
        jPanel14Layout.setHorizontalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 687, Short.MAX_VALUE)
        );
        jPanel14Layout.setVerticalGroup(
            jPanel14Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 140, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel12Layout = new javax.swing.GroupLayout(jPanel12);
        jPanel12.setLayout(jPanel12Layout);
        jPanel12Layout.setHorizontalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel13, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(jPanel15, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel12Layout.setVerticalGroup(
            jPanel12Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel12Layout.createSequentialGroup()
                .addComponent(jPanel13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(1, 1, 1)
                .addComponent(jPanel14, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel15, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        JTabbedPane_nodeControl.addTab("tab2", jPanel12);
        jPanel12.getAccessibleContext().setAccessibleParent(JTabbedPane_nodeControl);

        jPanel16.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jPanel17.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Emergency messages", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Arial", 1, 12))); // NOI18N

        JList_logWindow.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane4.setViewportView(JList_logWindow);

        javax.swing.GroupLayout jPanel17Layout = new javax.swing.GroupLayout(jPanel17);
        jPanel17.setLayout(jPanel17Layout);
        jPanel17Layout.setHorizontalGroup(
            jPanel17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 692, Short.MAX_VALUE)
        );
        jPanel17Layout.setVerticalGroup(
            jPanel17Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 134, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout jPanel16Layout = new javax.swing.GroupLayout(jPanel16);
        jPanel16.setLayout(jPanel16Layout);
        jPanel16Layout.setHorizontalGroup(
            jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel17, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel16Layout.setVerticalGroup(
            jPanel16Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        javax.swing.GroupLayout JPanel_canNodeControlLayout = new javax.swing.GroupLayout(JPanel_canNodeControl);
        JPanel_canNodeControl.setLayout(JPanel_canNodeControlLayout);
        JPanel_canNodeControlLayout.setHorizontalGroup(
            JPanel_canNodeControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(JTabbedPane_nodeControl, javax.swing.GroupLayout.DEFAULT_SIZE, 708, Short.MAX_VALUE)
            .addComponent(jPanel16, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        JPanel_canNodeControlLayout.setVerticalGroup(
            JPanel_canNodeControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_canNodeControlLayout.createSequentialGroup()
                .addComponent(JTabbedPane_nodeControl, javax.swing.GroupLayout.DEFAULT_SIZE, 522, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel16, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        JPanel_infoPanel.add(JPanel_canNodeControl, "card2");

        JPanel_syncControl.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        JPanel_syncControl.setFont(new java.awt.Font("Arial", 0, 12));
        JPanel_syncControl.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                JPanel_syncControlComponentHidden(evt);
            }
            public void componentShown(java.awt.event.ComponentEvent evt) {
                JPanel_syncControlComponentShown(evt);
            }
        });
        JPanel_syncControl.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                JPanel_syncControlFocusGained(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Current SYNC generator settings", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        jLabel2.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("SYNC message period: ");
        jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel4.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel4.setText("SYNC messages enabled:");
        jLabel4.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_syncPeriod.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_syncPeriod.setText("0");
        JLabel_syncPeriod.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_syncPeriod.setRequestFocusEnabled(false);

        JLabel_syncOnOff.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_syncOnOff.setText("YES");
        JLabel_syncOnOff.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_syncOnOff.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_syncOnOff.setRequestFocusEnabled(false);

        jLabel1.setText("ms");

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 179, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addComponent(JLabel_syncPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel1))
                    .addComponent(JLabel_syncOnOff, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(JLabel_syncOnOff))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2)
                    .addComponent(JLabel_syncPeriod))
                .addContainerGap(24, Short.MAX_VALUE))
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Set", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N
        jPanel2.setFont(new java.awt.Font("Arial", 0, 10));

        jLabel5.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel5.setText("SYNC message period:");
        jLabel5.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel7.setText("ms");

        JCheckBox_syncProducerOn.setFont(new java.awt.Font("Arial", 0, 12));
        JCheckBox_syncProducerOn.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        JCheckBox_syncProducerOn.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JCheckBox_syncProducerOn.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        JCheckBox_syncProducerOn.setMargin(new java.awt.Insets(0, 0, 0, 0));

        JSlider_setSyncPeriod.setFont(new java.awt.Font("Arial", 0, 10));
        JSlider_setSyncPeriod.setMajorTickSpacing(500);
        JSlider_setSyncPeriod.setMaximum(2500);
        JSlider_setSyncPeriod.setMinorTickSpacing(100);
        JSlider_setSyncPeriod.setPaintLabels(true);
        JSlider_setSyncPeriod.setPaintTicks(true);
        JSlider_setSyncPeriod.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                JSlider_setSyncPeriodStateChanged(evt);
            }
        });

        JText_syncPeriod.setColumns(5);
        JText_syncPeriod.setFont(new java.awt.Font("Arial", 0, 12));
        JText_syncPeriod.setText("jTextField1");
        JText_syncPeriod.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                JText_syncPeriodFocusLost(evt);
            }
        });
        JText_syncPeriod.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                JText_syncPeriodKeyPressed(evt);
            }
        });

        JButton_setSyncParameters.setText("Set");
        JButton_setSyncParameters.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JButton_setSyncParameters.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_setSyncParametersActionPerformed(evt);
            }
        });

        jLabel6.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel6.setText("Enable SYNC messages:");
        jLabel6.setRequestFocusEnabled(false);

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(29, 29, 29)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 162, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JCheckBox_syncProducerOn)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addComponent(JText_syncPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE))))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(JSlider_setSyncPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, 273, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(118, 118, 118)
                .addComponent(JButton_setSyncParameters))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JCheckBox_syncProducerOn)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(JText_syncPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel7))
                .addGap(15, 15, 15)
                .addComponent(JSlider_setSyncPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(JButton_setSyncParameters)
                .addContainerGap())
        );

        javax.swing.GroupLayout JPanel_syncControlLayout = new javax.swing.GroupLayout(JPanel_syncControl);
        JPanel_syncControl.setLayout(JPanel_syncControlLayout);
        JPanel_syncControlLayout.setHorizontalGroup(
            JPanel_syncControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_syncControlLayout.createSequentialGroup()
                .addGroup(JPanel_syncControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(401, Short.MAX_VALUE))
        );
        JPanel_syncControlLayout.setVerticalGroup(
            JPanel_syncControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_syncControlLayout.createSequentialGroup()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        JPanel_infoPanel.add(JPanel_syncControl, "card3");

        JPanel_timeControl.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        JPanel_timeControl.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                JPanel_timeControlComponentHidden(evt);
            }
            public void componentShown(java.awt.event.ComponentEvent evt) {
                JPanel_timeControlComponentShown(evt);
            }
        });

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Current TIME generator settings", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        jLabel8.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel8.setText("TIME message period: ");
        jLabel8.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel9.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel9.setText("TIME messages enabled:");
        jLabel9.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_timeProducerPeriod.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_timeProducerPeriod.setText("0");
        JLabel_timeProducerPeriod.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_timeProducerPeriod.setRequestFocusEnabled(false);

        JLabel_timeProducerOnOff.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        JLabel_timeProducerOnOff.setText("YES");
        JLabel_timeProducerOnOff.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_timeProducerOnOff.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        JLabel_timeProducerOnOff.setRequestFocusEnabled(false);

        jLabel10.setText("ms");

        jLabel14.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel14.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel14.setText("miliseconds since midnght:");
        jLabel14.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel15.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel15.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel15.setText("days since 01.01.1984:");
        jLabel15.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_milisecondsSinceMidnight.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_milisecondsSinceMidnight.setText("0");
        JLabel_milisecondsSinceMidnight.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_milisecondsSinceMidnight.setRequestFocusEnabled(false);

        JLabel_daysSince1984.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_daysSince1984.setText("0");
        JLabel_daysSince1984.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_daysSince1984.setRequestFocusEnabled(false);

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, 163, Short.MAX_VALUE)
                    .addComponent(jLabel14)
                    .addComponent(jLabel15, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JLabel_timeProducerOnOff, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JLabel_milisecondsSinceMidnight, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(jPanel3Layout.createSequentialGroup()
                        .addComponent(JLabel_timeProducerPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(JLabel_daysSince1984, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(JLabel_timeProducerOnOff))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(JLabel_timeProducerPeriod)
                    .addComponent(jLabel10))
                .addGap(20, 20, 20)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLabel_milisecondsSinceMidnight)
                    .addComponent(jLabel14))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLabel_daysSince1984)
                    .addComponent(jLabel15))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Set", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N
        jPanel4.setFont(new java.awt.Font("Arial", 0, 10));

        jLabel11.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel11.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel11.setText("TIME message period:");
        jLabel11.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        jLabel12.setText("ms");

        JCheckBox_timeProducerOn.setFont(new java.awt.Font("Arial", 0, 12));
        JCheckBox_timeProducerOn.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        JCheckBox_timeProducerOn.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JCheckBox_timeProducerOn.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        JCheckBox_timeProducerOn.setMargin(new java.awt.Insets(0, 0, 0, 0));

        JSlider_setTimeProducerPeriod.setFont(new java.awt.Font("Arial", 0, 10));
        JSlider_setTimeProducerPeriod.setMajorTickSpacing(500);
        JSlider_setTimeProducerPeriod.setMaximum(2500);
        JSlider_setTimeProducerPeriod.setMinorTickSpacing(100);
        JSlider_setTimeProducerPeriod.setPaintLabels(true);
        JSlider_setTimeProducerPeriod.setPaintTicks(true);
        JSlider_setTimeProducerPeriod.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                JSlider_setTimeProducerPeriodStateChanged(evt);
            }
        });

        JText_timeProducerPeriod.setColumns(5);
        JText_timeProducerPeriod.setFont(new java.awt.Font("Arial", 0, 12));
        JText_timeProducerPeriod.setText("jTextField1");
        JText_timeProducerPeriod.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                JText_timeProducerPeriodFocusLost(evt);
            }
        });
        JText_timeProducerPeriod.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                JText_timeProducerPeriodKeyPressed(evt);
            }
        });

        JButton_setTimeProducerParameters.setText("Set");
        JButton_setTimeProducerParameters.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_setTimeProducerParametersActionPerformed(evt);
            }
        });

        jLabel13.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel13.setText("Enable TIME messages:");
        jLabel13.setRequestFocusEnabled(false);

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addGap(29, 29, 29)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 162, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel13))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(JCheckBox_timeProducerOn)
                            .addGroup(jPanel4Layout.createSequentialGroup()
                                .addComponent(JText_timeProducerPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                    .addGroup(jPanel4Layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(JSlider_setTimeProducerPeriod, javax.swing.GroupLayout.DEFAULT_SIZE, 271, Short.MAX_VALUE)))
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap(134, Short.MAX_VALUE)
                .addComponent(JButton_setTimeProducerParameters)
                .addGap(106, 106, 106))
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JCheckBox_timeProducerOn)
                    .addComponent(jLabel13))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel11)
                    .addComponent(JText_timeProducerPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel12))
                .addGap(15, 15, 15)
                .addComponent(JSlider_setTimeProducerPeriod, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JButton_setTimeProducerParameters)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout JPanel_timeControlLayout = new javax.swing.GroupLayout(JPanel_timeControl);
        JPanel_timeControl.setLayout(JPanel_timeControlLayout);
        JPanel_timeControlLayout.setHorizontalGroup(
            JPanel_timeControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_timeControlLayout.createSequentialGroup()
                .addGroup(JPanel_timeControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, 0, 292, Short.MAX_VALUE)
                    .addComponent(jPanel3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(416, Short.MAX_VALUE))
        );
        JPanel_timeControlLayout.setVerticalGroup(
            JPanel_timeControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_timeControlLayout.createSequentialGroup()
                .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        JPanel_infoPanel.add(JPanel_timeControl, "card2");

        JPanel_devicesControl.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        JPanel_devicesControl.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentHidden(java.awt.event.ComponentEvent evt) {
                JPanel_devicesControlComponentHidden(evt);
            }
            public void componentShown(java.awt.event.ComponentEvent evt) {
                JPanel_devicesControlComponentShown(evt);
            }
        });

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Nodes state overview", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        jLabel19.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel19.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel19.setText("Total number of nodes:");
        jLabel19.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_totalNumberOfnodes.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_totalNumberOfnodes.setText("0");
        JLabel_totalNumberOfnodes.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_totalNumberOfnodes.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        JLabel_totalNumberOfnodes.setRequestFocusEnabled(false);

        jLabel22.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel22.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel22.setText("in preoperational state:");
        jLabel22.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_totalInPreoperational.setBackground(new java.awt.Color(255, 255, 0));
        JLabel_totalInPreoperational.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_totalInPreoperational.setText("0");
        JLabel_totalInPreoperational.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_totalInPreoperational.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        JLabel_totalInPreoperational.setOpaque(true);
        JLabel_totalInPreoperational.setRequestFocusEnabled(false);

        jLabel23.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel23.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel23.setText("in operational state:");
        jLabel23.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_totalInOperational.setBackground(new java.awt.Color(0, 255, 0));
        JLabel_totalInOperational.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_totalInOperational.setText("0");
        JLabel_totalInOperational.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_totalInOperational.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        JLabel_totalInOperational.setOpaque(true);
        JLabel_totalInOperational.setRequestFocusEnabled(false);

        jLabel24.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel24.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel24.setText("in stopped state:");
        jLabel24.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_totalInStopped.setBackground(new java.awt.Color(255, 0, 0));
        JLabel_totalInStopped.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_totalInStopped.setText("0");
        JLabel_totalInStopped.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_totalInStopped.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        JLabel_totalInStopped.setOpaque(true);
        JLabel_totalInStopped.setRequestFocusEnabled(false);

        jLabel25.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel25.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel25.setText("not responding (no heartbeat):");
        jLabel25.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);

        JLabel_totalInUnknown.setBackground(new java.awt.Color(255, 0, 255));
        JLabel_totalInUnknown.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        JLabel_totalInUnknown.setText("0");
        JLabel_totalInUnknown.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JLabel_totalInUnknown.setHorizontalTextPosition(javax.swing.SwingConstants.RIGHT);
        JLabel_totalInUnknown.setOpaque(true);
        JLabel_totalInUnknown.setRequestFocusEnabled(false);

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                        .addComponent(jLabel19, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(JLabel_totalNumberOfnodes, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(jLabel24, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel25, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addComponent(jLabel23, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel5Layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jLabel22, javax.swing.GroupLayout.PREFERRED_SIZE, 163, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(JLabel_totalInPreoperational, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(JLabel_totalInOperational, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(JLabel_totalInUnknown, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(JLabel_totalInStopped, javax.swing.GroupLayout.PREFERRED_SIZE, 71, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(14, Short.MAX_VALUE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLabel_totalNumberOfnodes)
                    .addComponent(jLabel19))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLabel_totalInPreoperational)
                    .addComponent(jLabel22))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLabel_totalInOperational)
                    .addComponent(jLabel23))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel24)
                    .addComponent(JLabel_totalInStopped))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(JLabel_totalInUnknown)
                    .addComponent(jLabel25))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Set nodes state", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11))); // NOI18N

        JButton_resetAll.setText("reset All nodes");
        JButton_resetAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_resetAllActionPerformed(evt);
            }
        });

        JButton_preoperationalAll.setBackground(new java.awt.Color(255, 255, 0));
        JButton_preoperationalAll.setText("set preoperational state");
        JButton_preoperationalAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_preoperationalAllActionPerformed(evt);
            }
        });

        JButton_operationalAll.setBackground(new java.awt.Color(51, 255, 51));
        JButton_operationalAll.setText("set operational state");
        JButton_operationalAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_operationalAllActionPerformed(evt);
            }
        });

        JButton_stopAll.setBackground(new java.awt.Color(255, 0, 0));
        JButton_stopAll.setText("set stopped mode");
        JButton_stopAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_stopAllActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addGap(113, 113, 113)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(JButton_stopAll)
                    .addComponent(JButton_operationalAll)
                    .addComponent(JButton_preoperationalAll)
                    .addComponent(JButton_resetAll))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(JButton_resetAll)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JButton_preoperationalAll)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JButton_operationalAll)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JButton_stopAll)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout JPanel_devicesControlLayout = new javax.swing.GroupLayout(JPanel_devicesControl);
        JPanel_devicesControl.setLayout(JPanel_devicesControlLayout);
        JPanel_devicesControlLayout.setHorizontalGroup(
            JPanel_devicesControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_devicesControlLayout.createSequentialGroup()
                .addGroup(JPanel_devicesControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel6, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(422, Short.MAX_VALUE))
        );
        JPanel_devicesControlLayout.setVerticalGroup(
            JPanel_devicesControlLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(JPanel_devicesControlLayout.createSequentialGroup()
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        JPanel_infoPanel.add(JPanel_devicesControl, "card2");

        jSplitPane1.setRightComponent(JPanel_infoPanel);

        JTollbar_statusBar.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        JLabel_Status1.setText("status  1");
        JLabel_Status1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));
        JTollbar_statusBar.add(JLabel_Status1);

        jPanel18.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.LOWERED));

        jLabel46.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel46.setText(" Device Context: ");

        JComboBox_deviceContext.setMaximumSize(new java.awt.Dimension(100, 30));
        JComboBox_deviceContext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JComboBox_deviceContextActionPerformed(evt);
            }
        });

        jLabel48.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel48.setText(" Device Subsystem: ");

        JComboBox_deviceSubsystem.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        JComboBox_deviceSubsystem.setMaximumSize(new java.awt.Dimension(100, 30));

        jLabel47.setFont(new java.awt.Font("Tahoma", 1, 11));
        jLabel47.setText(" Device Server: ");

        JComboBox_deviceServer.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        JComboBox_deviceServer.setMaximumSize(new java.awt.Dimension(100, 30));

        JButton_connect.setText("Connect");
        JButton_connect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                JButton_connectActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel18Layout = new javax.swing.GroupLayout(jPanel18);
        jPanel18.setLayout(jPanel18Layout);
        jPanel18Layout.setHorizontalGroup(
            jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel18Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel46)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JComboBox_deviceContext, javax.swing.GroupLayout.PREFERRED_SIZE, 135, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jLabel48)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(JComboBox_deviceSubsystem, javax.swing.GroupLayout.PREFERRED_SIZE, 131, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(27, 27, 27)
                .addComponent(jLabel47)
                .addGap(18, 18, 18)
                .addComponent(JComboBox_deviceServer, javax.swing.GroupLayout.PREFERRED_SIZE, 151, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(JButton_connect)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel18Layout.setVerticalGroup(
            jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel18Layout.createSequentialGroup()
                .addGap(4, 4, 4)
                .addGroup(jPanel18Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel46)
                    .addComponent(JComboBox_deviceContext, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel48)
                    .addComponent(JComboBox_deviceSubsystem, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel47)
                    .addComponent(JComboBox_deviceServer, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(JButton_connect, javax.swing.GroupLayout.PREFERRED_SIZE, 21, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(JTollbar_statusBar, javax.swing.GroupLayout.DEFAULT_SIZE, 907, Short.MAX_VALUE)
                    .addComponent(jPanel18, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 907, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(jPanel18, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(1, 1, 1)
                .addComponent(jSplitPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 605, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(JTollbar_statusBar, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void JComboBox_deviceContextActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JComboBox_deviceContextActionPerformed
    {//GEN-HEADEREND:event_JComboBox_deviceContextActionPerformed
// TODO add your handling code here:
    }//GEN-LAST:event_JComboBox_deviceContextActionPerformed

    private void JButton_sdoWriteActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_sdoWriteActionPerformed
    {//GEN-HEADEREND:event_JButton_sdoWriteActionPerformed
        currentlySelectedCanNodeDevice.sdoWrite(Integer.parseInt(JText_index.getText(), 16), 
                                                Integer.parseInt(JText_subindex.getText(), 16),
                                                JText_odWrite.getText().trim());
    }//GEN-LAST:event_JButton_sdoWriteActionPerformed

    private void JBUTTON_sdoReadActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JBUTTON_sdoReadActionPerformed
    {//GEN-HEADEREND:event_JBUTTON_sdoReadActionPerformed
        currentlySelectedCanNodeDevice.sdoRead( Integer.parseInt(JText_index.getText(), 16), 
                                                Integer.parseInt(JText_subindex.getText(), 16) );
    }//GEN-LAST:event_JBUTTON_sdoReadActionPerformed

    private void JButton_setHeartbeatParametersActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_setHeartbeatParametersActionPerformed
    {//GEN-HEADEREND:event_JButton_setHeartbeatParametersActionPerformed
        currentlySelectedCanNodeDevice.setHeartBeatControl(JCheckBox_heartbeat.isSelected(), Integer.parseInt(JText_heartbeatPeriod.getText()));
    }//GEN-LAST:event_JButton_setHeartbeatParametersActionPerformed

    private void JText_heartbeatPeriodKeyPressed(java.awt.event.KeyEvent evt)//GEN-FIRST:event_JText_heartbeatPeriodKeyPressed
    {//GEN-HEADEREND:event_JText_heartbeatPeriodKeyPressed
        char c;
        if( (c = evt.getKeyChar()) =='\n' ) JSlider_setHeartbeatPeriod.setValue(Integer.parseInt(JText_heartbeatPeriod.getText()));
    }//GEN-LAST:event_JText_heartbeatPeriodKeyPressed

    private void JText_heartbeatPeriodFocusLost(java.awt.event.FocusEvent evt)//GEN-FIRST:event_JText_heartbeatPeriodFocusLost
    {//GEN-HEADEREND:event_JText_heartbeatPeriodFocusLost
    JSlider_setHeartbeatPeriod.setValue(Integer.parseInt(JText_heartbeatPeriod.getText()));
    }//GEN-LAST:event_JText_heartbeatPeriodFocusLost

    private void JSlider_setHeartbeatPeriodStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_JSlider_setHeartbeatPeriodStateChanged
    {//GEN-HEADEREND:event_JSlider_setHeartbeatPeriodStateChanged
        JText_heartbeatPeriod.setText( Integer.toString( JSlider_setHeartbeatPeriod.getValue()));
    }//GEN-LAST:event_JSlider_setHeartbeatPeriodStateChanged

    private void JButton_stopNodeActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_stopNodeActionPerformed
    {//GEN-HEADEREND:event_JButton_stopNodeActionPerformed
            currentlySelectedCanNodeDevice.requestNMT(CanNodeDevice.NMTREQ_STOP);
    }//GEN-LAST:event_JButton_stopNodeActionPerformed

    private void JButton_operationalNodeActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_operationalNodeActionPerformed
    {//GEN-HEADEREND:event_JButton_operationalNodeActionPerformed
        currentlySelectedCanNodeDevice.requestNMT(CanNodeDevice.NMTREQ_OPERATIONAL);
    }//GEN-LAST:event_JButton_operationalNodeActionPerformed

    private void JButton_preoperationalNodeActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_preoperationalNodeActionPerformed
    {//GEN-HEADEREND:event_JButton_preoperationalNodeActionPerformed
        currentlySelectedCanNodeDevice.requestNMT(CanNodeDevice.NMTREQ_PREOPERATIONAL);
    }//GEN-LAST:event_JButton_preoperationalNodeActionPerformed

    private void JButton_resetNodeActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_resetNodeActionPerformed
    {//GEN-HEADEREND:event_JButton_resetNodeActionPerformed
         currentlySelectedCanNodeDevice.requestNMT(CanNodeDevice.NMTREQ_RESET);
    }//GEN-LAST:event_JButton_resetNodeActionPerformed

    private void JButton_stopAllActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_stopAllActionPerformed
    {//GEN-HEADEREND:event_JButton_stopAllActionPerformed
        allNodesToStopped();
    }//GEN-LAST:event_JButton_stopAllActionPerformed

    private void JButton_operationalAllActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_operationalAllActionPerformed
    {//GEN-HEADEREND:event_JButton_operationalAllActionPerformed
        allNodesToOperational();
    }//GEN-LAST:event_JButton_operationalAllActionPerformed

    private void JButton_preoperationalAllActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_preoperationalAllActionPerformed
    {//GEN-HEADEREND:event_JButton_preoperationalAllActionPerformed
        allNodesToPreOperational();
    }//GEN-LAST:event_JButton_preoperationalAllActionPerformed

    void allNodesReset()            { executeAllNodesNMT("ALLRESET"); }
    void allNodesToOperational()    { executeAllNodesNMT("ALLOP");    }
    void allNodesToStopped()        { executeAllNodesNMT("ALLSTOP");  }
    void allNodesToPreOperational() { executeAllNodesNMT("ALLPREOP"); }
    
    private int executeAllNodesNMT( String property)
    {
        int error;
        String devname = new String(TicomView.TicomViewer.getServerPath() +"/COMAN");
        //int[] dummy = new int[1];        
        //TDataType din = new TDataType(dummy);
        TLink l = new TLink(devname,property,null,null ,TAccess.CA_WRITE);        
        if( (error = l.execute(1000)) != 0 )
        {
            System.out.println("Error execute (executeAllNodesNMT): " + l.getLinkStatus());
        }
        l.close();
        return error;  
    }
    
    private void JButton_resetAllActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_resetAllActionPerformed
    {//GEN-HEADEREND:event_JButton_resetAllActionPerformed
        allNodesReset();
    }//GEN-LAST:event_JButton_resetAllActionPerformed

    private void JPanel_devicesControlComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_JPanel_devicesControlComponentShown
    {//GEN-HEADEREND:event_JPanel_devicesControlComponentShown
// TODO add your handling code here:
    }//GEN-LAST:event_JPanel_devicesControlComponentShown

    private void JPanel_devicesControlComponentHidden(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_JPanel_devicesControlComponentHidden
    {//GEN-HEADEREND:event_JPanel_devicesControlComponentHidden
// TODO add your handling code here:
    }//GEN-LAST:event_JPanel_devicesControlComponentHidden

    private void JPanel_busControlComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_JPanel_busControlComponentShown
    {//GEN-HEADEREND:event_JPanel_busControlComponentShown
// TODO add your handling code here:
    }//GEN-LAST:event_JPanel_busControlComponentShown

    private void JPanel_busControlComponentHidden(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_JPanel_busControlComponentHidden
    {//GEN-HEADEREND:event_JPanel_busControlComponentHidden
// TODO add your handling code here:
    }//GEN-LAST:event_JPanel_busControlComponentHidden

    private void JPanel_timeControlComponentHidden(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_JPanel_timeControlComponentHidden
    {//GEN-HEADEREND:event_JPanel_timeControlComponentHidden
        timeProducerInfoLinkClose();
    }//GEN-LAST:event_JPanel_timeControlComponentHidden

    private void JPanel_timeControlComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_JPanel_timeControlComponentShown
    {//GEN-HEADEREND:event_JPanel_timeControlComponentShown
        timeProducerInfoLinkOpen();
    }//GEN-LAST:event_JPanel_timeControlComponentShown

    private void JPanel_syncControlComponentHidden(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_JPanel_syncControlComponentHidden
    {//GEN-HEADEREND:event_JPanel_syncControlComponentHidden
        syncInfoLinkClose();
    }//GEN-LAST:event_JPanel_syncControlComponentHidden
    
    private void JButton_setTimeProducerParametersActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_setTimeProducerParametersActionPerformed
    {//GEN-HEADEREND:event_JButton_setTimeProducerParametersActionPerformed
        setTimeProducerParameters( JCheckBox_timeProducerOn.isSelected(), Integer.parseInt(JText_timeProducerPeriod.getText()));
    }//GEN-LAST:event_JButton_setTimeProducerParametersActionPerformed
    
    private void JText_timeProducerPeriodKeyPressed(java.awt.event.KeyEvent evt)//GEN-FIRST:event_JText_timeProducerPeriodKeyPressed
    {//GEN-HEADEREND:event_JText_timeProducerPeriodKeyPressed
        char c;
        if( (c = evt.getKeyChar()) =='\n' ) JSlider_setTimeProducerPeriod.setValue(Integer.parseInt(JText_timeProducerPeriod.getText()));
    }//GEN-LAST:event_JText_timeProducerPeriodKeyPressed
    
    private void JText_timeProducerPeriodFocusLost(java.awt.event.FocusEvent evt)//GEN-FIRST:event_JText_timeProducerPeriodFocusLost
    {//GEN-HEADEREND:event_JText_timeProducerPeriodFocusLost
        JSlider_setTimeProducerPeriod.setValue(Integer.parseInt(JText_timeProducerPeriod.getText()));
    }//GEN-LAST:event_JText_timeProducerPeriodFocusLost
    
    private void JSlider_setTimeProducerPeriodStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_JSlider_setTimeProducerPeriodStateChanged
    {//GEN-HEADEREND:event_JSlider_setTimeProducerPeriodStateChanged
        JText_timeProducerPeriod.setText( Integer.toString(JSlider_setTimeProducerPeriod.getValue()));
    }//GEN-LAST:event_JSlider_setTimeProducerPeriodStateChanged
    
    private void JText_syncPeriodFocusLost(java.awt.event.FocusEvent evt)//GEN-FIRST:event_JText_syncPeriodFocusLost
    {//GEN-HEADEREND:event_JText_syncPeriodFocusLost
        JSlider_setSyncPeriod.setValue(Integer.parseInt(JText_syncPeriod.getText()));
    }//GEN-LAST:event_JText_syncPeriodFocusLost
    
    private void JButton_setSyncParametersActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_setSyncParametersActionPerformed
    {//GEN-HEADEREND:event_JButton_setSyncParametersActionPerformed
       setSyncProducerParameters( JCheckBox_syncProducerOn.isSelected(), Integer.parseInt(JText_syncPeriod.getText()));
    }//GEN-LAST:event_JButton_setSyncParametersActionPerformed
    
    private void JText_syncPeriodKeyPressed(java.awt.event.KeyEvent evt)//GEN-FIRST:event_JText_syncPeriodKeyPressed
    {//GEN-HEADEREND:event_JText_syncPeriodKeyPressed
        char c;
        if( (c = evt.getKeyChar()) =='\n' ) JSlider_setSyncPeriod.setValue(Integer.parseInt(JText_syncPeriod.getText()));
    }//GEN-LAST:event_JText_syncPeriodKeyPressed
    
    private void JSlider_setSyncPeriodStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_JSlider_setSyncPeriodStateChanged
    {//GEN-HEADEREND:event_JSlider_setSyncPeriodStateChanged
        JText_syncPeriod.setText( Integer.toString(JSlider_setSyncPeriod.getValue()));
    }//GEN-LAST:event_JSlider_setSyncPeriodStateChanged
    
    private void JPanel_syncControlComponentShown(java.awt.event.ComponentEvent evt)//GEN-FIRST:event_JPanel_syncControlComponentShown
    {//GEN-HEADEREND:event_JPanel_syncControlComponentShown
       syncInfoLinkOpen();
    }//GEN-LAST:event_JPanel_syncControlComponentShown
    
    private void JPanel_syncControlFocusGained(java.awt.event.FocusEvent evt)//GEN-FIRST:event_JPanel_syncControlFocusGained
    {//GEN-HEADEREND:event_JPanel_syncControlFocusGained
    }//GEN-LAST:event_JPanel_syncControlFocusGained
    
    private void JTree_CanBusValueChanged(javax.swing.event.TreeSelectionEvent evt)//GEN-FIRST:event_JTree_CanBusValueChanged
    {//GEN-HEADEREND:event_JTree_CanBusValueChanged
      ((Node)evt.getPath().getLastPathComponent()).showControlPanel();
    }//GEN-LAST:event_JTree_CanBusValueChanged

    private void JButton_connectActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_JButton_connectActionPerformed
    {//GEN-HEADEREND:event_JButton_connectActionPerformed
       int error;
       reset();

       if(JComboBox_deviceContext.getSelectedIndex() < 0 || JComboBox_deviceServer.getSelectedIndex() < 0) return;
       selectTicomServer( "/"+JComboBox_deviceContext.getSelectedItem().toString().trim()                
                        + "/" + JComboBox_deviceServer.getSelectedItem().toString().trim() );                               
       if( (error = ticomInfoRead()) == 0 ) canopenBusTreeModel.addDefaultDevices();
       else System.out.println( "Can't read ticomInfo(), error = " + error +", " + TErrorList.getErrorString(error));
       JTree_CanBus.repaint();
    
}//GEN-LAST:event_JButton_connectActionPerformed
            
    /**
     * @param args the command line arguments
     */
    public static TicomView TicomViewer;
    public static void main(String args[])
    {
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());          
        }
        catch( Exception e)
        {
            throw new RuntimeException(e);
        }
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            @Override
            public void run()
            {
                (TicomViewer = new TicomView()).setVisible(true);
            }
        });
    }
     
    private void selectTicomServer( String serverPath )
    {
        System.out.println("Selecting: " + serverPath);
        this.serverPath = serverPath;
    }
    
    public String getServerPath() 
    { 
        return serverPath;
    }
    
    private int ticomInfoRead()
    {
        int error;
        String devname = new String( getServerPath()+"/COMAN");
        
        busInfoLink = new TLink(devname,"BUSINFO",new TDataType(BusInfoData),null,TAccess.CA_READ);
        if( (error = busInfoLink.execute(1000) ) != 0 ) return error; 
        if( (error = busInfoLink.attach(TMode.CM_POLL | TMode.CM_WAIT , new TicomInfo(), 1000)) < 0)
        {
            System.out.println("attach failed (ticomInfoRead): " + busInfoLink.getLinkStatus() + ", " +  busInfoLink.getLastError());            
        }
        return 0;
    }
    
    private void syncInfoLinkOpen()
    {
        String devname = new String(getServerPath() + "/SYNC");
        int[] periodOnOff = new int[2];
        SyncInfoLink = new TLink(devname,"periodOnOff",new TDataType(periodOnOff),null,TAccess.CA_READ);
        
        if (SyncInfoLink.attach(TMode.CM_POLL, canopenBusTreeModel.getSyncProducer(), 1000) < 0)
        {
            System.out.println("attach failed (syncInfoLinkOpen): " + SyncInfoLink.getLinkStatus());
        }
        return;
    }
    
    
    void showSyncControlPanel(SyncProducer syncProducer)
    {
        displayControlPanel(JPanel_syncControl);
    }
    
    void displayControlPanel( JPanel p )
    {
        //it is assumed, that JPanel has a CardLayout
        Component c[] = JPanel_infoPanel.getComponents();
        for( int i = 0; i < c.length; i++ ) c[i].setVisible(c[i].equals(p));
    }
    
    void showTimeControlPanel(TimeProducer timeProducer)
    {
        displayControlPanel(JPanel_timeControl);
    }
    
    private void initControls()
    {
        // 1. set SYNC period text
        JText_syncPeriod.setText( Integer.toString(JSlider_setSyncPeriod.getValue()));
        // 2. Time producer text
        JText_timeProducerPeriod.setText( Integer.toString(JSlider_setTimeProducerPeriod.getValue()));        
        // 3. load TICOM comboBox selections
        loadTicomSelections();
        // 4. create EmcyLog window
        EmcyLog = new EmcyDisplay(JList_logWindow);
        // 5. create FlashProgrammerDispalyer
        flashProgrammerDisplayer = new FlashProgrammerDisplayer();
        JTabbedPane_nodeControl.addTab("Maintenance", flashProgrammerDisplayer);
    }
     
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton JBUTTON_sdoRead;
    private javax.swing.JButton JButton_connect;
    private javax.swing.JButton JButton_operationalAll;
    private javax.swing.JButton JButton_operationalNode;
    private javax.swing.JButton JButton_preoperationalAll;
    private javax.swing.JButton JButton_preoperationalNode;
    private javax.swing.JButton JButton_resetAll;
    private javax.swing.JButton JButton_resetNode;
    private javax.swing.JButton JButton_sdoWrite;
    private javax.swing.JButton JButton_setHeartbeatParameters;
    private javax.swing.JButton JButton_setSyncParameters;
    private javax.swing.JButton JButton_setTimeProducerParameters;
    private javax.swing.JButton JButton_stopAll;
    private javax.swing.JButton JButton_stopNode;
    private javax.swing.JCheckBox JCheckBox_heartbeat;
    private javax.swing.JCheckBox JCheckBox_syncProducerOn;
    private javax.swing.JCheckBox JCheckBox_timeProducerOn;
    private javax.swing.JComboBox JComboBox_deviceContext;
    private javax.swing.JComboBox JComboBox_deviceServer;
    private javax.swing.JComboBox JComboBox_deviceSubsystem;
    public javax.swing.JLabel JLabel_Status1;
    public javax.swing.JLabel JLabel_busSpeed;
    public javax.swing.JLabel JLabel_daysSince1984;
    public javax.swing.JLabel JLabel_deviceType;
    public javax.swing.JLabel JLabel_hardwareVersion;
    public javax.swing.JLabel JLabel_heartbeatEnabled;
    public javax.swing.JLabel JLabel_heartbeatPeriod;
    public javax.swing.JLabel JLabel_manufactureDeviceName;
    public javax.swing.JLabel JLabel_milisecondsSinceMidnight;
    public javax.swing.JLabel JLabel_noHeartBeatTime;
    public javax.swing.JLabel JLabel_nodeId;
    public javax.swing.JLabel JLabel_nodeName;
    public javax.swing.JLabel JLabel_numberOfNodes;
    public javax.swing.JLabel JLabel_odRead;
    public javax.swing.JLabel JLabel_odReadStatus;
    public javax.swing.JLabel JLabel_operationalCounter;
    public javax.swing.JLabel JLabel_operationalEntryTime;
    public javax.swing.JLabel JLabel_preOperationalCounter;
    public javax.swing.JLabel JLabel_preoperationalEntryTime;
    public javax.swing.JLabel JLabel_productCode;
    public javax.swing.JLabel JLabel_resetCounter;
    public javax.swing.JLabel JLabel_resetEntryTime;
    public javax.swing.JLabel JLabel_revisionNumber;
    public javax.swing.JLabel JLabel_serialNumber;
    public javax.swing.JLabel JLabel_softwareVersion;
    public javax.swing.JLabel JLabel_stopEntryTime;
    public javax.swing.JLabel JLabel_stoppedCounter;
    public javax.swing.JLabel JLabel_syncOnOff;
    public javax.swing.JLabel JLabel_syncPeriod;
    public javax.swing.JLabel JLabel_ticomStartTime;
    public javax.swing.JLabel JLabel_ticomVersion;
    public javax.swing.JLabel JLabel_timeProducerOnOff;
    public javax.swing.JLabel JLabel_timeProducerPeriod;
    public javax.swing.JLabel JLabel_totalInOperational;
    public javax.swing.JLabel JLabel_totalInPreoperational;
    public javax.swing.JLabel JLabel_totalInStopped;
    public javax.swing.JLabel JLabel_totalInUnknown;
    public javax.swing.JLabel JLabel_totalNumberOfnodes;
    public javax.swing.JLabel JLabel_vendorId;
    private javax.swing.JList JList_logWindow;
    public javax.swing.JPanel JPanel_NMT;
    private javax.swing.JPanel JPanel_busControl;
    private javax.swing.JPanel JPanel_canNodeControl;
    private javax.swing.JPanel JPanel_devicesControl;
    private javax.swing.JPanel JPanel_infoPanel;
    private javax.swing.JPanel JPanel_syncControl;
    private javax.swing.JPanel JPanel_timeControl;
    private javax.swing.JSlider JSlider_setHeartbeatPeriod;
    private javax.swing.JSlider JSlider_setSyncPeriod;
    private javax.swing.JSlider JSlider_setTimeProducerPeriod;
    private javax.swing.JTabbedPane JTabbedPane_nodeControl;
    public javax.swing.JTable JTable_rPdoVariables;
    public javax.swing.JTable JTable_tPdoVariables;
    private javax.swing.JTextField JText_heartbeatPeriod;
    private javax.swing.JTextField JText_index;
    private javax.swing.JTextField JText_odWrite;
    private javax.swing.JTextField JText_subindex;
    private javax.swing.JTextField JText_syncPeriod;
    private javax.swing.JTextField JText_timeProducerPeriod;
    private javax.swing.JToolBar JTollbar_statusBar;
    private javax.swing.JTree JTree_CanBus;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel17;
    private javax.swing.JLabel jLabel18;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JLabel jLabel21;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel26;
    private javax.swing.JLabel jLabel27;
    private javax.swing.JLabel jLabel28;
    private javax.swing.JLabel jLabel29;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel30;
    private javax.swing.JLabel jLabel31;
    private javax.swing.JLabel jLabel32;
    private javax.swing.JLabel jLabel33;
    private javax.swing.JLabel jLabel34;
    private javax.swing.JLabel jLabel35;
    private javax.swing.JLabel jLabel36;
    private javax.swing.JLabel jLabel37;
    private javax.swing.JLabel jLabel38;
    private javax.swing.JLabel jLabel39;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel40;
    private javax.swing.JLabel jLabel41;
    private javax.swing.JLabel jLabel42;
    private javax.swing.JLabel jLabel43;
    private javax.swing.JLabel jLabel44;
    private javax.swing.JLabel jLabel45;
    private javax.swing.JLabel jLabel46;
    private javax.swing.JLabel jLabel47;
    private javax.swing.JLabel jLabel48;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel10;
    private javax.swing.JPanel jPanel11;
    private javax.swing.JPanel jPanel12;
    private javax.swing.JPanel jPanel13;
    private javax.swing.JPanel jPanel14;
    private javax.swing.JPanel jPanel15;
    private javax.swing.JPanel jPanel16;
    private javax.swing.JPanel jPanel17;
    private javax.swing.JPanel jPanel18;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JSplitPane jSplitPane1;
    // End of variables declaration//GEN-END:variables
    
    private class TicomInfo implements TLinkCallback
    {    
        @Override
        public void callback(TLink lnk)
        {       
            if (lnk.getLinkStatus() != 0)
            {
                System.out.println("Link Error (TicomInfo): " + lnk.getLastError());
                JLabel_Status1.setText( lnk.getLastError() );     
                return;
            }   
            canopenBusTreeModel.updateBusInfo(BusInfoData);           
            //if( canopenBus.updateBusInfo(BusInfoData) )canopenBus.dump();                
        }
    }
    
    private void setSyncProducerParameters(boolean syncOn, int syncPeriod)
    {
        String devname = new String(TicomView.TicomViewer.getServerPath() +"/SYNC");
        int[] periodOnOff = new int[2];
        periodOnOff[0] = syncOn ? 1 : 0;
        periodOnOff[1] = syncPeriod;
        TDataType din = new TDataType(periodOnOff);
        TLink busInfoLnk = new TLink(devname,"periodOnOff",null,din ,TAccess.CA_WRITE);
        
        if(busInfoLnk.execute(1000) != 0 )
        {
            System.out.println("Error execute (setSyncProducerParameters): " + busInfoLink.getLinkStatus());
        }
        return;
    }
    
    private void setTimeProducerParameters(boolean timeProducerOn, int timeProducerPeriod)
    {
        String devname = new String(TicomView.TicomViewer.getServerPath() +"/TIMEPRODUCER");
        int[] periodOnOff = new int[2];
        periodOnOff[0] = timeProducerOn ? 1 : 0;
        periodOnOff[1] = timeProducerPeriod;
        TDataType din = new TDataType(periodOnOff);
        TLink busInfoLnk = new TLink(devname,"periodOnOff",null,din ,TAccess.CA_WRITE);
        
        if( busInfoLnk.execute(1000) != 0 )
        {
            System.out.println("Error execute (setTimeProducerParameters): " + busInfoLink.getLinkStatus());
        }
        busInfoLnk.close();
        return;
    }

    private void timeProducerInfoLinkOpen()
    {
        String devname = new String(TicomView.TicomViewer.getServerPath() +"/TIMEPRODUCER");
        int[] periodOnOff = new int[2];
        TimeProducerInfoLink = new TLink(devname,"periodOnOff",new TDataType(periodOnOff),null,TAccess.CA_READ);
        
        if (TimeProducerInfoLink.attach(TMode.CM_POLL, canopenBusTreeModel.getTimeProducer(), 1000) < 0)
        {
            System.out.println("attach error (TimeProducerInfoLink):" + TimeProducerInfoLink.getLinkStatus());
        }
        return;
    }

    private void syncInfoLinkClose()
    {        
         if( SyncInfoLink != null ) SyncInfoLink.close();            
    }

    private void timeProducerInfoLinkClose()
    {        
        if( TimeProducerInfoLink != null ) TimeProducerInfoLink.close();        
    }

    void showBusControlPanel(CanopenBusTreeModel canopenBus)
    {
       displayControlPanel(JPanel_busControl);
    }

    void showDevicesControlPanel(CanDevices canDevices)
    {
        displayControlPanel(JPanel_devicesControl);
    }

    void showCanNodeControlPanel(CanNodeDevice canNodeDevice)
    {
        JTabbedPane_nodeControl.setTitleAt(0,"Node Basic Information");
        JTabbedPane_nodeControl.setTitleAt(1,"Node Data");
        if( currentlySelectedCanNodeDevice != null )
        {
            currentlySelectedCanNodeDevice.closeLinks();
            currentlySelectedCanNodeDevice.setProgrammerDisplay(null);
        }
        EmcyLog.reset();
        currentlySelectedCanNodeDevice = canNodeDevice;        
        canNodeDevice.readNodeIdInfo(); 
        canNodeDevice.readNodeData();
        CanNodeIdInfo ci = canNodeDevice.getCanNodeIdInfo();
        JLabel_nodeId.setText("0x" + Integer.toHexString(ci.nodeId[0]) + ", (" + Integer.toString(ci.nodeId[0]) + ")" );
        JLabel_nodeName.setText(canNodeDevice.getName());   
        JLabel_deviceType.setText("0x" + Integer.toHexString(ci.deviceType[0]));
        JLabel_vendorId.setText(Integer.toString(ci.vendorId[0]) + "  ( 0x" + Integer.toHexString(ci.vendorId[0]) + " )");
        JLabel_productCode.setText(Integer.toString(ci.productCode[0])+ "  ( 0x" + Integer.toHexString(ci.productCode[0]) + " )");
        JLabel_revisionNumber.setText(Integer.toString(ci.revisionNumber[0]) + "  ( 0x" + Integer.toHexString(ci.revisionNumber[0]) + " )");
        JLabel_serialNumber.setText(Integer.toString(ci.serialNumber[0]) + "  ( 0x" + Integer.toHexString(ci.serialNumber[0]) + " )");
        JLabel_manufactureDeviceName.setText(ci.manufactureDeviceName.toString());
        JLabel_hardwareVersion.setText(ci.hardwareVersion.toString());
        JLabel_softwareVersion.setText(ci.softwareVersion.toString());
        canNodeDevice.attachHeartBeatLink();
        canNodeDevice.flashProgrammerAssignDevice();
        canNodeDevice.setProgrammerDisplay(flashProgrammerDisplayer);
        displayControlPanel(JPanel_canNodeControl);    
        EmcyLog.setOwner(currentlySelectedCanNodeDevice);
        EmcyLog.enable();
    }

    private void loadTicomSelections()
    {
       JComboBox_deviceContext.addActionListener(new ActionListener() 
        {
            @Override
            public void actionPerformed(ActionEvent e) 
            {
                fillInSubsystem();
            }
        });        
       JComboBox_deviceSubsystem.addActionListener(new ActionListener() 
        {           
            @Override
            public void actionPerformed(ActionEvent e) 
            {
              if(JComboBox_deviceSubsystem.getSelectedIndex() < 0) return;            
              fillInDeviceServers();              
            }
       }); 
   
       /*
       JComboBox_deviceServer.addActionListener( new ActionListener()
        {
           public void actionPerformed(ActionEvent e)
           {
               int error;
               reset();
              
               if(JComboBox_deviceContext.getSelectedIndex() < 0 || JComboBox_deviceServer.getSelectedIndex() < 0) return;
               selectTicomServer( "/"+JComboBox_deviceContext.getSelectedItem().toString().trim()                
                                + "/" + JComboBox_deviceServer.getSelectedItem().toString().trim() );                               
               if( (error = ticomInfoRead()) == 0 ) canopenBus.addDefaultDevices();
               else System.out.println( "Can't read ticomInfo(), error = " + error +", " + TErrorList.getErrorString(error));
               JTree_CanBus.repaint();
           }
        });
       */
       
       fillInContexts();       
    }
    
  private void fillInContexts()
  {
    // copied from InstanBrawser.java  
    JComboBox_deviceContext.removeAllItems();
    JComboBox_deviceContext.addItem("DEFAULT");
    String[] contexts = TQuery.getContexts();
    if (contexts != null)
    {
      Arrays.sort(contexts);
      for (int i = 0; i < contexts.length; i++)
      {
        JComboBox_deviceContext.addItem(contexts[i].trim());
      }
    }
  }
  
  private void fillInSubsystem()
  {
    JComboBox_deviceSubsystem.removeAllItems();
    JComboBox_deviceSubsystem.addItem("ALL");
    if (JComboBox_deviceContext.getSelectedIndex() < 0) return;
    String[] subsystems = TQuery.getDeviceSubsystems(JComboBox_deviceContext.getSelectedItem().toString());
    if(subsystems != null)
    {
      Arrays.sort(subsystems);
      for (int i = 0; i < subsystems.length; i++)
      {
        if( !subsystems[i].trim().equals("")) JComboBox_deviceSubsystem.addItem(subsystems[i].trim());
      }
    }
  }
  
   private void fillInDeviceServers()
  {
    if (JComboBox_deviceContext.getSelectedIndex() < 0) return;
    if (JComboBox_deviceSubsystem.getSelectedIndex() < 0) return;
    
    JComboBox_deviceServer.removeAllItems();
    String[] svrs = TQuery.getDeviceServers( JComboBox_deviceContext.getSelectedItem().toString(),
                                             JComboBox_deviceSubsystem.getSelectedItem().toString());
    if (svrs == null) return;
    Arrays.sort(svrs);
    for (int i = 0; i < svrs.length; i++)
    {
      JComboBox_deviceServer.addItem(svrs[i].trim());
    }
  }  

    private void reset()
    {
        JTree_CanBus.collapsePath(new TreePath(JTree_CanBus.getModel().getRoot()));
       
        // close links
        if(busInfoLink != null) busInfoLink.close();
        syncInfoLinkClose();
        timeProducerInfoLinkClose();
        if( currentlySelectedCanNodeDevice != null ) currentlySelectedCanNodeDevice.closeLinks();
        EmcyLog.reset();
       // delete tree items       
        canopenBusTreeModel.removeDevices(); 
        
        JLabel_ticomVersion.setText("-");
        JLabel_ticomStartTime.setText("-");
        JLabel_numberOfNodes.setText("-");
        JLabel_busSpeed.setText("-");
    }
}
class BusInfo extends TTaggedStructure
{
    private static final int MAX_NODE_IMAGE_COUNT = 127;
    
    public static final int HEARTBEAT_TIMEOUT = 0x8000;
    public static final int BOOT_UP = 0;
    public static final int PREOPERATIONAL = 127;
    public static final int OPERATIONAL = 5;
    public static final int STOPPED = 4;

    public int[]  nNodes = new int[1];
    public FixedString[] nodeName = new FixedString[MAX_NODE_IMAGE_COUNT]; 
    public FixedString busName = new FixedString(33);
    public int[]  nodeState = new int[MAX_NODE_IMAGE_COUNT];
    public int[]  syncState = new int[1];
    public int[]  timeProducerState = new int[1];    
    public int[]  busSpeed = new int[1];
    public FixedString[] ticomVersion = new FixedString[1];
    public FixedString[] ticomStartTime = new FixedString[1];
    
    BusInfo()
    {
        super("BUSINFO");
        for( int i = 0; i < MAX_NODE_IMAGE_COUNT; i++) nodeName[i] = new FixedString(33);
        addField(nNodes,"nNodes");
        for( int i = 0; i < MAX_NODE_IMAGE_COUNT; i++) addField(nodeName[i].getBytes(), "nodeName"+i);
        addField(busName.getBytes(), "busName");
        addField(nodeState,"nodeState");        
        addField(syncState,"syncState");
        addField(timeProducerState,"timeProducerState");
        addField(busSpeed,"busSpeed");
        ticomVersion[0] = new FixedString(64);
        ticomStartTime[0] = new FixedString(64);
        addField( ticomVersion[0].getBytes(), "ticomVersion");
        addField( ticomStartTime[0].getBytes(), "ticomStartTime");
        initDone();      
    }
}
 

